# -*- coding: utf-8 -*-

import googsystray
import gtk
import os
import types
import copy
import stat

from xml.etree import ElementTree as ET

import GMain
import GPopupWindow
import GNotification

if os.name == "nt":
        default_popup_dshadow = False
else:
        default_popup_dshadow = True

default_account = {
			"username": _("your.name@gmail.com"),
			"password": "",
			"type": "Google",
			"services": {
				"gmail": True,
				"gv": False,
				"greader": False,
				"gcal": False,
				"gwave": False,
				"gdocs": False,
				},
		}
				

default_gmail_notification = {
				"hidden":	False,
				"webname":	"Inbox",
				"name": 	"Inbox",
				"enable_sound" : 	True,
				"sound_file" : 	"$New_Mail-Notification.wav",
				"enable_other": False,
				"other_command": "",
			}

default_gv_notification = [
			{
				"hidden":	False,
				"name":		"SMS Message",
				"webname":	"sms",
				"enable_sound":	True,
				"sound_file":	"$SMS-Notification.wav",
				"enable_other": False,
				"other_command": ""
			},
			{
				"hidden":	False,
				"name": 	"Voicemail",
				"webname":	"voicemail",
				"enable_sound":	True,
				"sound_file":	"$SMS-Notification.wav",
				"enable_other": False,
				"other_command": ""
			},
		]
			
default_gcal_notification = { 
				"hidden":	False,
				"name" :	"Reminder",
				"webname":	"reminder",
				"account" :	"Default",
				"enable_sound" :	True,
				"sound_file" :	"$New_Reminder-Notification.wav",
				"enable_other": False,
				"other_command": "",
		}

default_greader_notification = {
				"hidden":	False,
				"name" : "Article",
				"webname" : "article",
				"account" : "Default",
				"enable_sound" : True,
				"sound_file" : "$New_Reader-Notification.wav",
				"enable_other": False,
				"other_command": ""
		}
		
default_gwave_notification = {
				"hidden":	False,
				"name" : "Wave",
				"webname" : "wave",
				"enable_sound" : True,
				"sound_file" : "$New_Reader-Notification.wav",
				"enable_other": False,
				"other_command": ""
		}

default_gdocs_notification = {
				"hidden":	False,
				"name" : "Document",
				"webname" : "doc",
				"enable_sound" : True,
				"sound_file" : "$New_Reader-Notification.wav",
				"enable_other": False,
				"other_command": ""
		}



default_gconfig = { 
	"gv": { 
		"always_show_icon": False,
		"dim_icon": False,
		"display_count": True,
		"service_name": "Google Voice",
		"icon": "Google-Voice-64.png",
		"timeout": googsystray.DEFAULT_TIMEOUT/2,
		"not_allowhide": False,
		"not_treeview": False,
		"sub_notifications" : [],

		"hotkeys": { 
			"new_sms" : 	{
				"name": _("Send SMS Message"),
				"keys": "<Control><Super>S",
			},
			"new_call" :  {
				"name": _("Make a Phone Call"),
				"keys": "<Control><Super>C",
			},
		},
	},
	"gmail": { 
		"always_show_icon": False,
		"service_name": "GMail",
		"dim_icon": False,
		"display_count": True,
		"icon": "Google-gMail-64.png",
		"timeout": googsystray.DEFAULT_TIMEOUT,
		"not_allowhide": True,
		"not_treeview": True,
		"sub_notifications" : [],
		"hotkeys": { 
			"open_gmail" :  {
				"name": _("Open GMail"),
				"keys": "<None>",
			},
			"compose_email" : {
				"name": _("Compose Email"),
				"keys": "<Control><Super>E",
			},
		},
	},
	"gcal": { 
		"always_show_icon": False,
		"dim_icon": False,
		"display_count": False,
		"service_name": "Google Calendar",
		"icon": "Google-Calendar-64.png",
		"timeout": googsystray.DEFAULT_TIMEOUT,
		"hotkeys": {},
		"not_allowhide": False,
		"not_treeview": False,
		"sub_notifications" : [],
	},
	"gdocs": { 
		"always_show_icon": False,
		"dim_icon": False,
		"display_count": True,
		"service_name": "Google Docs",
		"icon": "Google-Docs-64.png",
		"timeout": googsystray.DEFAULT_TIMEOUT,
		"hotkeys": {},
		"not_allowhide": False,
		"not_treeview": False,
		"sub_notifications" : [],
	},
	"greader": { 
		"always_show_icon": False,
		"dim_icon": False,
		"display_count": True,
		"service_name": "Google Reader",
		"icon": "Google-Reader-64.png",
		"show_by_label": True,
		"timeout": googsystray.DEFAULT_TIMEOUT,
		"minimum_unread": 25,
		"minimum_notify_once": True,
		"hotkeys": {},
		"not_allowhide": False,
		"not_treeview": False,
		"sub_notifications" : [],
	},
	"gwave": { 
		"always_show_icon": False,
		"dim_icon": False,
		"display_count": True,
		"service_name": "Google Wave",
		"icon": "Google-Wave-64.png",
		"timeout": googsystray.DEFAULT_TIMEOUT,
		"notify_once": True,
		"hotkeys": {},
		"not_allowhide": False,
		"not_treeview": False,
		"sub_notifications" : [],
	},
	"global": {
		"use": True,
		"accounts": { },
		"hotkeys": { 
			"show_main_icon" : 	{ 
				"name" : "Show/Hide Main Icon",
				"keys": "<Control><Super>G",
				},
			},
		"popup_style": "native",
		"popup_scheme": "blue",
		"popup_size": 0.75,
		"popup_opacity": 1.0,
		"popup_dshadow": default_popup_dshadow,
		"popup_dshadow_str": 0.5,
		"popup_dshadow_size": 4,
		"popup_sticky": True,
		"popup_ontop": True,
		"popup_bg_color1": "#A0A0FF",
		"popup_bg_color2": "#FFFFFF",
		"popup_border_color": "#FFFFFF",
		"popup_font_color": "#000000",   		
		"browser_action": googsystray.ONCLICK_NEW_TAB,
		"browser_cmd": "",
		"vis_notify": "none",
		"vis_notify_timeout": 5,
		"always_show_icon": True,
		"icon": "Google-64.png",
		"dim_icons": True,
		"timeout": -1,
	}
}


def parseHotKey(hkey):
	mods = 0
	c = 0
	if hkey == "<None>":
		return (None, None)
	if hkey[c] != "<":
		return (mods, hkey)
	while hkey[c] == "<":
		c1 = hkey.find(">", c)
		if c1 == -1:
			return (mods, "<")
		if hkey[c+1: c1] == "Control":
			mods |= GMain.MOD_CONTROL
		elif hkey[c+1: c1] == "Alt":
			mods |= GMain.MOD_ALT
		elif hkey[c+1: c1] == "Shift":
			mods |= GMain.MOD_SHIFT
		elif hkey[c+1: c1] == "Super":
			mods |= GMain.MOD_SUPER
		else:
			print hkey[c+1: c1] + " unknown modifier!"
		c = c1+1
	
	return (mods, hkey[c:])
			

class GConf:

	def destroy(self, widget, data=None):
		for i in GMain._GMain, GPopupWindow, GNotification:
			i.close_config(False)
			
		for i in GMain._services:
			i["class"].close_config(False)

		if GMain.configOnly:
			gtk.main_quit()
		self.window.destroy()
		self.window = None
		return False


	def _ok(self, cl):
		for j in cl.entries:
			dict = j.get_data("set_dict")
			dict[j.get_data("dict_entry")] = j.get_text()
		cl.close_config(True)

	def ok(self, widget, data=None):
		for i in GMain._GMain, GPopupWindow, GNotification:
			self._ok(i)
		
		for i in GMain._services:
			self._ok(i["class"])
		
		if not GMain.configOnly:
			for i in GMain._services:
				i["class"].stop()
			GMain._GMain.stop()

		self.gconfig = self.backupconfig
		self.save_config()
		if not GMain.configOnly:
			self.window.destroy()
			self.window = None
			# Otherwise, the window sits a bit -- people might think
			# the UI is unresponsive.
			while gtk.events_pending():
				gtk.main_iteration(False)

			GMain._GMain.start()
			for i in GMain._services:
				i["class"].start()
		else:
			gtk.main_quit()
		
		return False

	def open_config_window(self, data=None):
		if self.window is not None:
			return
		self.backupconfig = copy.deepcopy(self.gconfig)
		
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.connect("delete_event", self.destroy)
		self.window.set_title(_("Configuration"))
		self.window.set_default_size(640,480)
		notebook = gtk.Notebook()
		notebook.set_tab_pos(gtk.POS_LEFT)
		
		vbox = gtk.VBox()
		vbox.pack_start(notebook, True, True, 2)
		hbox = gtk.HBox()
		vbox.pack_start(hbox, False, False, 2)
		button = gtk.Button("OK", gtk.STOCK_OK)
		button.connect("clicked", self.ok)
		hbox.pack_end(button, False, False, 2)
		button = gtk.Button("Cancel", gtk.STOCK_CANCEL)
		button.connect("clicked", self.destroy)
		hbox.pack_end(button, False, False, 2)
		
		self.window.add(vbox)
		
		vbox = gtk.VBox()
		notebook.append_page(vbox, gtk.Label("General"))
		vbox.show()
		GMain._GMain.draw_config(vbox)
		
		for i in GMain._services:
			vbox = gtk.VBox()
			notebook.append_page(vbox, gtk.Label(i["longname"]))
			vbox.show()
			i["class"].draw_config(vbox)

		vbox = gtk.VBox()
		notebook.append_page(vbox, gtk.Label(_("Popup Windows")))
		vbox.show()
		GPopupWindow.draw_config(vbox)

		vbox = gtk.VBox()
		notebook.append_page(vbox, gtk.Label(_("Visual Notifications")))
		vbox.show()
		GNotification.draw_config(vbox)

		self.window.show_all()
		
	def elements_to_map(self, i, conf, in_arr = False):
		iname = i.attrib["name"]
		in_list = False
		if in_arr:
			d_app = conf
		else:
			d_app = conf[iname]
		
		for j in i.getchildren():
		
			if i.tag == "list":
				# Only dicts are stored in lists
				# at the moment.
				jname = j.attrib["name"]
				in_list = True
			else:
				jname = j.attrib["name"]

			if j.tag == "none":
				d_app[jname] = None
				continue
			if j.tag == "bool":
				if j.text == "True":
					d_app[jname] = True
				else:
					d_app[jname] = False
			if j.tag == "int":
				d_app[jname] = int(j.text)
			if j.tag == "float":
				d_app[jname] = float(j.text)
			if j.tag == "string":
				d_app[jname] = j.text
			if j.tag == "dict":
				if not in_list:
					if d_app.get(jname) == None:
						d_app[jname] = {}
					self.elements_to_map(j, d_app)
				else:
					dict_get = {}
					self.elements_to_map(j, dict_get, True)
					d_app.append(dict_get)
					
			if j.tag == "list":
				if d_app.get(jname) == None:
					d_app[jname] = []
					
				self.elements_to_map(j, d_app)

	def older_than(self, version1, version2):
		v1 = version1.split(".")	
		maj1 = v1[0]
		min1 = v1[1]
		rev1 = v1[2]

		v2 = version2.split(".")	
		maj2 = v2[0]
		min2 = v2[1]
		rev2 = v2[2]
		
		if maj1 < maj2:
			return True
		elif maj1 > maj2:
			return False
			
		if min1 < min2:
			return True
		elif min1 > min2:
			return False
			
		if rev1 < rev2:
			return True
		return False
	

	def elements_clean_old(self, version):


	
		if self.older_than(version, "1.1.0"):
			self.gconfig["global"]["popup_opacity"] = 1.0
			self.gconfig["global"]["popup_style"] = "native"
			self.gconfig["global"]["popup_blue"] = "blue"

			self.gconfig["global"]["accounts"]["Default"] = {}
			
			dacc = self.gconfig["global"]["accounts"]["Default"]
			dacc["username"] = self.gconfig["global"].pop("username")
			dacc["password"] = self.gconfig["global"].pop("password")
			dacc["type"] = "Google"
			dacc["services"] = {}
			dacc["services"]["gmail"] = self.gconfig["gmail"].pop("use")
			dacc["services"]["gv"] = self.gconfig["gv"].pop("use")
			dacc["services"]["gcal"] = self.gconfig["gcal"].pop("use")
			dacc["services"]["greader"] = self.gconfig["greader"].pop("use")
			if "use" in self.gconfig["gwave"]:
				dacc["services"]["gwave"] = self.gconfig["gwave"].pop("use")
			else:
				dacc["services"]["gwave"] = False
			
			for i in self.gconfig.items():
				if "notifications" not in i[1]:
					continue
				for j in i[1]["notifications"].items():
					j[1]["account"] = "Default"
					j[1]["webname"] = j[0]
					if "label_name" in j[1]:
						del j[1]["label_name"]
					if j[1]["name"].endswith(" email"):
						j[1]["name"] = j[1]["name"][:-6]
					self.gconfig[i[0]]["sub_notifications"].append(j[1])
				del i[1]["notifications"]

				del i[1]["onclick_action"]
				del i[1]["onclick_url"]
				del i[1]["onclick_other_cmd"]
				
			# Specific for gmail, move Inbox to the front.
			c = 0
			arr = self.gconfig["gmail"]["sub_notifications"]
			for i in arr:
				if i["name"] == "Inbox":
					arr.insert(0, arr.pop(c))
					break
				c += 1
		
		if self.older_than(version, "1.2.0"):
			for i in self.gconfig["global"]["accounts"].items():
				print i
				if not "gdocs" in i[1]["services"]:
					i[1]["services"]["gdocs"] = False
					dnot = copy.deepcopy(default_gdocs_notification)
					dnot["account"] = i[0]
					self.gconfig["gdocs"]["sub_notifications"].append(dnot)


			

				
			
		
		
	def load_config(self):
		fname = os.path.join(googsystray.config_dir, googsystray.config_name)

		self.gconfig = default_gconfig
		try: 
			tree = ET.parse(fname)
			# set permissions here, just in case
			os.chmod(fname, stat.S_IRUSR | stat.S_IWUSR)
		except IOError:
			GMain.firstRun = True
			return
		root = tree.getroot()
		for i in root.getchildren():
			if self.gconfig.get(i.attrib["name"]) == None:
				self.gconfig[i.attrib["name"]] = {}
			self.elements_to_map(i, self.gconfig)
			
		self.elements_clean_old(root.attrib["version"])
				
	def map_to_elements(self, node, j):
		if (type(j[1]) == types.StringType):
			node2 = ET.SubElement(node, "string")
			node2.set("name", j[0])
			node2.text = j[1]
		elif (type(j[1]) == types.BooleanType):
			node2 = ET.SubElement(node, "bool")
			node2.set("name", j[0])
			if (j[1]):
				node2.text = "True"
			else:
				node2.text = "False"
		elif (type(j[1]) == types.IntType):
			node2 = ET.SubElement(node, "int")
			node2.set("name", j[0])
			node2.text = str(j[1])
		elif (type(j[1]) == types.FloatType):
			node2 = ET.SubElement(node, "float")
			node2.set("name", j[0])
			node2.text = str(j[1])
		elif (type(j[1]) == types.DictType):
			node2 = ET.SubElement(node, "dict")
			node2.set("name", j[0])
			if j[0] == "DNSDATA": 
				return
			for k in j[1].items():
				self.map_to_elements(node2, k)
		elif (type(j[1]) == types.ListType):
			node2 = ET.SubElement(node, "list")
			node2.set("name", j[0])
			cnt = 0
			for k in j[1]:
				self.map_to_elements(node2, (str(cnt), k))
				cnt += 1
		else:
			node2 = ET.SubElement(node, "none")
			node2.set("name", j[0])
	
		
	def save_config(self):
		root = ET.Element("config")
		root.set("version", googsystray.VERSION_STRING)

		for i in self.gconfig.items():
			node = ET.SubElement(root, "folder")
			node.set("name", i[0])
			for j in i[1].items():
				self.map_to_elements(node, j)
						
		fname = os.path.join(googsystray.config_dir, googsystray.config_name)

		tree = ET.ElementTree(root)
		tree.write(fname, encoding="utf-8")
		os.chmod(fname, stat.S_IRUSR | stat.S_IWUSR)


	def __init__ (self):
		self.window = None
		self.load_config()

