# -*- coding: utf-8 -*-

from GBase import GBase

from xml.etree import ElementTree as ET

_w05 = "{http://www.w3.org/2005/Atom}"
_w07 = "{http://www.w3.org/2007/app}"
_g05 = "{http://schemas.google.com/g/2005}"
_g08 = "{http://schemas.google.com/contact/2008}"

class GContacts(GBase):

	def dumpit(self, node, depth=0):
		for i in range(depth):
			print "\t",
		print "<" + node.tag.encode("utf-8"),
		for i in node.attrib:
			print " " + i + " = \"" + node.attrib[i].encode("utf-8") + "\"",
		print ">",
		if node.text != None:
			print node.text.encode("utf-8")
		else:
			print ""
		
		for i in node.getchildren():
			self.dumpit(i, depth+1)
			
	def getContactsWithPhones(self):
		return self.phoneContacts
	

	def getEntry(self, node):
		title = ""
		id = ""
		givenName = ""
		familyName = ""
		nameSuffix = ""
		namePrefix = ""
		additionalName = ""
		birthday = ""
		phoneNumbers = []
		emailAddresses = []
		ET.dump(node)
		for i in node.getchildren():
#			self.dumpit(i)
			if i.tag == _w05+"id":
				id = i.text[68:]
			elif i.tag == _w05+"title":
				title = i.text
			elif i.tag == _g05+"phoneNumber":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				phoneNumbers.append({"primary":p, "type":type, "number":i.text})
			elif i.tag == _g05+"email":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				emailAddresses.append({"primary":p, "type":type, "address":i.attrib["address"]})
			elif i.tag == _g05+"name":
				for j in i.getchildren():
					if j.tag == _g05+"givenName":
						givenName = j.text
					elif j.tag == _g05+"familyName":
						familyName = j.text
					elif j.tag == _g05+"nameSuffix":
						nameSuffix = j.text
					elif j.tag == _g05+"namePrefix":
						namePrefix = j.text
					elif j.tag == _g05+"additionalName":
						additionalName = j.text
					elif j.tag == _g05+"fullName":
						pass
					else:
						# fixme, popup an error
						# for the user to send me a message!
						self.dumpit(j)
			elif i.tag == _g08+"birthday":
				birthday = i.attrib.get("when")
				# This format is YYYY-MM-DD
				# eg 1980-05-14 OR --05-14 for no year
			elif i.tag == _g08+"website":
#				self.dumpit(i)
				pass
			elif i.tag == _g05+"im":
				pass
				#TODO save IM's like email/phone above
			elif i.tag == _w05+"link":
				pass
				#TODO the contact image is in here,
				#hopefully we can merge this with our GV cache
			elif i.tag == _g08+"groupMembershipInfo":
				#TODO groups are important.
				pass
			elif i.tag == _g08+"relation":
				#TODO relationships, could be multiple
				pass
			elif i.tag == _g05+"structuredPostalAddress":
				#TODO save postal address
				for j in i.getchildren():
					if j.tag == _g05+"formattedAddress":
						pass
					else:
						self.dumpit(i)
			elif i.tag == _w05+"content":
				#TODO notes
				pass
			elif i.tag == _g05+"organization":
				for j in i.getchildren():
					if j.tag == _g05+"orgName":
						pass
					elif j.tag == _g05+"orgTitle":
						pass
					else:
						self.dumpit(i)
			elif i.tag == _g08+"nickname":
				pass
			elif i.tag == _g08+"event":
				# i.attrib.get("rel")
				# "anniversary"/"other"
				for j in i.getchildren():
					if j.tag == _g05+"when":
						# j.attrib.get("startTime")
						pass
					else:
						self.dumpit(i)
			elif i.tag == _g08+"userDefinedField":
				# i.attrib.get("value")
				# i.attrib.get("key")
				pass
########################The following contents, TODO eventually delete
######################## Just here to avoid dumping them
			elif i.tag == _w05+"updated":
				pass
			elif i.tag == _w07+"edited":
				pass
			elif i.tag == _w05+"category":
				pass
########################
			else:
				self.dumpit(i)
				pass
					
				
		if title != None:
			if self.contacts.get(id) == None:
				self.contacts[id] = {}
			self.contacts[id]["title"] = title
			self.contacts[id]["phone"] = phoneNumbers
			self.contacts[id]["email"] = emailAddresses
			self.contacts[id]["givenName"] = givenName
			self.contacts[id]["familyName"] = familyName
			self.contacts[id]["nameSuffix"] = nameSuffix
			self.contacts[id]["namePrefix"] = namePrefix
			self.contacts[id]["additionalName"] = additionalName
			self.contacts[id]["birthday"] = birthday
			
			self.contacts[id]["id"] = id # yes, we need this
			

	def check_data(self):
		if self.account["name"] not in self.auth or self.auth[self.account["name"]] == None:
			self.get_auth(self.account, 'cp')
			
		headers = {"Authorization" : self.auth[self.account["name"]],
			   "GData-Version" : "3"}
		
		url = "http://www.google.com/m8/feeds/contacts/default/full?max-results=10000"
		if self.updatedTime != None:
			url += "&updated-min=" + self.updatedTime
			
		data = self.urlopen2(self.account, url, headers=headers)

		if data == None:
			return
		#print data
			
		root = ET.XML(data)

		for i in root.getchildren():
			if i.tag == _w05+"updated":
				self.updatedTime=i.text
			if i.tag == _w05+"entry":
				self.getEntry(i)


		self.phoneContacts = []
		for i in self.contacts.items():
			if i[1]["phone"] == []:
				continue;
			inserted = False
			pos = 0
			for j in self.phoneContacts:
				if j["title"] > i[1]["title"]:
					inserted = True
					self.phoneContacts.insert(pos, i[1])
					break
				pos+=1
			if not inserted:
				self.phoneContacts.append(i[1])

		return True
		
	def set_account(self, acct):
		self.account = acct

	def stop(self):
		self.stop_timer()
		return

	def start(self):
		self.start_timer()

	def __init__ (self):
		GBase.__init__(self)
		# 15 minutes
		self.account = None
		self.timeout = 15*60000
		self.updatedTime = None
		self.contacts = {}
		self.phoneContacts = []
		self.config = "contacts"
		