# -*- coding: utf-8 -*-

import googsystray
import gtk, gobject
import urlparse
import urllib
import copy
import os

from struct import *

import GIcon
import GMain
import GConf
import GPopupWindow
import htmltextview	

class GMail(GIcon.GIcon):
	def label_clicked(self, widget, event, data=None):
		label = widget.get_child()
		message = widget.get_data("thr_data")

		for i in GMain._accounts:
			if i["name"] == message["account"]:
				account = i
				break

		if account["type"] == "Apps":
			base_url = "https://mail.google.com/a/" + account["domain"]
		else:
			base_url = "https://mail.google.com/mail"
			
		thr_id = message["data"]["thr_id"]


		if data == "markread":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Marking...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=rd&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "markspam":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Marking...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=sp&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "trash":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Deleting...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=tr&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "archive":
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Archiving...")) + "</span>")
			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=ar&at=" + account["gmail_at"], message)
			widget.set_sensitive(False)
		elif data == "ignore":
			message["marked"] = True
			gobject.idle_add(self.update_icon, None)
		elif data == "minimize":
			vbox = widget.get_data("vbox")
			if vbox.props.visible:
				vbox.hide()
				self.popup_window.window.reshow_with_initial_size()
			else:
				vbox.show_all()
		
		elif data == "open":
			self.browser_open(base_url + "/?shva=1#label/" + self.fix_label_name(message["data"]["label"]) + "/" + thr_id)
			self.thread_lock.acquire()
			for i in self.messages_unread:
				if i["id"] == message["id"]:
					i["marked"] = True
					break
			self.thread_lock.release()
			gobject.idle_add(self.update_icon, None)

			
	
		return
		
	def popup_body_destroy(self):
		self.popup_body_window = None	
		
	def hv_browser_open(self, view, url, type):
		self.browser_open(url)
		
	def popup_body(self, message):
		if self.popup_body_window is not None:
			return
			
		if message["marked"] or self.popup_window is None:
			return
			
		data = message["data"]
		body = message["pdata"]
		if body is None:
			body = "<body>" + _("Downloading Message...") + "</body>"
		(m_x, m_y, m_mask) = self.staticon.get_screen().get_root_window().get_pointer()
		m_x -= 20
		m_y -= 20

		hv = htmltextview.HtmlTextView()
		hv.display_html(body)
		hv.connect("url-clicked", self.hv_browser_open)
		sw = gtk.ScrolledWindow()
		sw.set_property("hscrollbar-policy", gtk.POLICY_NEVER)
		sw.set_property("vscrollbar-policy", gtk.POLICY_AUTOMATIC)
		sw.set_property("border-width", 0)
		sw.add(hv)

		title = data["subj"]


		self.popup_body_window = GPopupWindow.get_new_popup_window_clean(
			self.popup_body_destroy, title,
			m_x, m_y,
			icon=os.path.join(googsystray.BASE_DIR, "icons", self.get_config()["icon"]))

		self.popup_body_window.vbox.pack_start(sw, True, True, 5)

		self.popup_body_window.window.set_default_size(int(480 * self.get_gconfig()["popup_size"]), int(320 * self.get_gconfig()["popup_size"])) 
		self.popup_body_window.show_all()
		return False

	def draw_message(self, message):
		mvbox = self.popup_window.vbox
		
		vbox = gtk.VBox()
		mvbox.pack_start(vbox, False, False, 0)
		vbox.set_data("msg_id", message["id"])
		self.popup_messages.append(vbox)

		sep = gtk.HSeparator()
		vbox.pack_start(sep, False, False, 3)

		if self.num_used() > 1:
			labelname = message["account"] + " - " + message["data"]["label"]
		else:
			labelname = message["data"]["label"]

		from_markup = "<b>%(str1)s</b> %(str2)s" % { "str1" : _("From:"),
						             "str2" : self.clean_label(message["data"]["from"]) }
		subj_markup = "<b>%(str1)s</b> %(str2)s" % { "str1" : _("Subject:"),
						             "str2" : self.clean_label(message["data"]["subj"]) }
		time_markup = "  <span color=\"#404040\">" + message["data"]["time"] + "</span>"
		
		label_label = gtk.Label()
		label_label.set_markup("<span color=\"#404040\"><i>(" + labelname + ")</i></span>")

		from_label = GIcon.link_label(from_markup, self.label_clicked, "open")
		from_label.set_data("thr_data", message)
		from_label.set_popup_func(self.popup_body, message, 1000)
		subj_label = GIcon.link_label(subj_markup, self.label_clicked, "open")
		subj_label.set_data("thr_data", message)
		subj_label.set_popup_func(self.popup_body, message, 1000)
		time_label = GIcon.link_label(time_markup, self.label_clicked, "open")
		time_label.set_popup_func(self.popup_body, message, 1000)
		time_label.set_data("thr_data", message)

		hbox = gtk.HBox()
		hbox.pack_start(from_label, False, False, 2)
		hbox.pack_start(time_label, False, False, 2)
		if message["data"]["has_attachment"]:
			image = self.new_image_labelsize("Attachment.png")
			hbox.pack_start(image, False, False, 3)

		min_image = self.new_image_button("Minimize.png", self.label_clicked, "minimize")
		min_image.set_data("thr_data", message)
		hbox.pack_end(min_image, False, False, 2)
		image = self.new_image_button("Ignore.png", self.label_clicked, "ignore")
		image.set_data("thr_data", message)
		hbox.pack_end(image, False, False, 2)
		hbox.pack_end(label_label, False, False, 2)
		vbox.pack_start(hbox, False, False, 2)


		vbox2 = gtk.VBox()
		vbox.pack_start(vbox2, False, False, 0)
		min_image.set_data("vbox", vbox2)
		
		hbox = gtk.HBox()
		hbox.pack_start(subj_label, False, False, 2)
		vbox2.pack_start(hbox, False, False, 2)
		
		hbox3 = gtk.HBox()
		vbox2.pack_start(hbox3, False, False, 5)
		


		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Delete")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "trash")
		button.set_data("thr_data", copy.deepcopy(message))
		button.set_popup_func(self.popup_body, message, 3000)
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Archive")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "archive")
		button.set_data("thr_data", copy.deepcopy(message))
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Mark as read")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "markread")
		button.set_data("thr_data", copy.deepcopy(message))
		button.set_popup_func(self.popup_body, message, 3000)
		hbox3.pack_end(button, True, True, 10)

		button=GIcon.link_label()
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Mark as spam")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "markspam")
		button.set_data("thr_data", copy.deepcopy(message))
		hbox3.pack_end(button, True, True, 10)
		
		vbox.show_all()
		
	def make_new_label(self, account, label_str, hidden):
		label_str2 = urllib.quote(label_str, "")
		
		for i in self.get_config()["sub_notifications"]:
			if i["name"] == label_str and i["account"] == account["name"]:
				return
				
		new_not = copy.deepcopy(GConf.default_gmail_notification)
		new_not["account"] = account["name"]
		new_not["hidden"] = hidden
		new_not["webname"] = label_str2
		new_not["name"] = label_str
		self.get_config()["sub_notifications"].append(new_not)
			
		GMain._GConf.save_config()


	def dumpit(self, node, depth=0):
		for i in range(depth):
			print "  ",
		print "<" + node.tag.encode("utf-8"),
		for i in node.attrib:
			print " " + i + " = \"" + node.attrib[i].encode("utf-8") + "\"",
		print ">",
		if node.text != None:
			print node.text.encode("utf-8")
		else:
			print ""
		
		for i in node.getchildren():
			self.dumpit(i, depth+1)
		
	def get_string(self, i, data):
		# it seems an error can occur here that I'm not sure
		# exactly how it happens.  short data from google,
		# but we need to handle it FIXME
		len = 0
		(len,) = unpack('!H', data[i:i+2])
		i += 2
		str = data[i:i+len]
		i += len
		return (i, str)


	# Is this the only one?  I'm not sure...  Apparently with the mobile
	# API it doesn't want /'s replaced with %2F.  I'm sure other special
	# chars will cause problems as well.  
	def fix_label_name(self, label):
		return label.replace("/", "-")

	def compose_email(self, to=None, cc=None, bcc=None, subj=None, body=None):
		base_url = None
		#Fixme -- this uses the first gmail account, but
		#it ought to use a default
		for i in GMain._accounts:
			if not i["services"][self.config]:
				continue
			if i["type"] == "Apps":
				base_url = "https://mail.google.com/a/" + i["domain"]
			else:
				base_url = "https://mail.google.com/mail"
			break
				
		print base_url
		if base_url == None:
			return

		params = { "view": "cm",
			   "tf": "0" }
		if to != None:
			params["to"] = to
		if cc != None:
			params["cc"] = cc
		if bcc != None:
			params["bcc"] = bcc 
		if subj != None:
			params["su"] = subj
		if body != None:
			params["body"] = body 
			
		self.browser_open(base_url + "?" + urllib.urlencode(params))
		
	def compose_email2(self, widget, data=None):
		self.compose_email()
		
	def parse_mailto(self, mailto):
		to=""
		cc=None
		bcc=None
		subj=None
		body=None
		if mailto[:6] == "inbox:":
			self.browser_open("https://mail.google.com")
			return
		if mailto[:7] == "mailto:":
			mailto=mailto[7:]
		c = mailto.find("?")
		if c == -1:
			to = mailto
		else:
			to = mailto[:c]
			o = urlparse.parse_qsl(mailto[c+1:])
			for i in o:
				(key, val) = i
				if key == "subject":
					subj = val
				elif key == "body":
					body = val
				elif key == "cc":
					cc = val
				elif key == "bcc":
					bcc = val
		self.compose_email(to, cc, bcc, subj, body)
			
	def icon_check_data(self, account):
		new_messages = []
		
		if account["type"] == "Apps":
			base_url = "https://mail.google.com/a/" + account["domain"]
		else:
			base_url = "https://mail.google.com/mail"

		if not account["name"] in self.got_cookies or not self.got_cookies[account["name"]]:
			data = self.urlopen2(account, base_url + "/x/432141/&s=l&l=Inbox")
			self.got_cookies[account["name"]] = False
			for i in account["cproc"].cookiejar:
				if i.name == "GMAIL_AT":
					account["gmail_at"] = i.value
					self.got_cookies[account["name"]] = True
			if not self.got_cookies[account["name"]]:
				print "Error on " + account["name"]
					
		for i in self.get_config()["sub_notifications"]:
			if i["account"] != account["name"]:
				continue
			if i["hidden"]:
				continue
			o = 0
			fname = self.fix_label_name(i["name"])
			cont = True
			sz = 20
			st = 0
			maxdeep = 10
			nu = 0
			
			while cont:
				cont = False
				
				maxdeep -= 1
				if maxdeep < 0:
					continue
					
				urlstr = base_url + "/m/5435345/?p=1.1&s=cat&sz=" + str(sz) + "&st=" + str(st) + "&cat=" + fname
				
				data = self.urlopen2(account, urlstr)
			
				if data == None:
					continue
					
				c = 0;
				(c, status) = self.get_string(c, data)
				if status != "T":
					continue
				# fixme status should be 'T', do error checking
				(c, id_code) = self.get_string(c, data)
				(c, st_thread) = self.get_string(c, data)
				(c, num_threads) = self.get_string(c, data)
				(c, tot_threads) = self.get_string(c, data)
				(c, num_unread) = self.get_string(c, data)
				
				for j in range(int(num_threads)):
					(c, is_read_str) = self.get_string(c, data)
					(c, is_starred_str) = self.get_string(c, data)
					(c, has_attachments_str) = self.get_string(c, data)
					if has_attachments_str == "T":
						has_attachments = True
					else:
						has_attachments = False
					(c, from_str) = self.get_string(c, data)
					(c, subject_str) = self.get_string(c, data)
					(c, time_str) = self.get_string(c, data)
					(c, url_str) = self.get_string(c, data)

					if is_read_str == "F":
						nu+=1
						new_messages.append(
							{ "id": url_str + from_str + time_str,
							  "sub_id": i["webname"],
							  "account": account["name"],
							  "count": 1,
							  "title": from_str, # Fixme, needs to include [account] + label
							  "summary": subject_str,
							  "icon": None,
							  "marked": False,
							  "data": { "label" : i["name"],
							  	    "from"  : from_str,
							  	    "subj"  : subject_str,
							  	    "time"  : time_str,
							  	    "thr_id": url_str[4:],
							  	    "has_attachment": has_attachments,
							  	  },
							  "pdata" : None,
							})
						o += 1
								    
				(c, num_labels) = self.get_string(c, data)
				for j in range(int(num_labels)):
					(c, label_str) = self.get_string(c, data)
					(c, num_unread_str) = self.get_string(c, data)
					self.make_new_label(account, label_str, True)
				
				if nu < int(num_unread):
					cont = True
					st += sz

		self.merge_messages(account["name"], new_messages)
		self.download_all_emails(account)
		return True
		
	def download_email(self, account, message):
		if account["type"] == "Apps":
			base_url = "https://mail.google.com/a/" + account["domain"]
		else:
			base_url = "https://mail.google.com/mail"
		
		urlstr = base_url + "/h/5435345/?v=pt&msg=" + message["data"]["thr_id"]
		body = self.urlopen2(account, urlstr)
			
		if body == None:
			return "Unable to download message."
			
		'''
		c = data.find("Content-Type:")
		c1 = data.find(";", c)
		ctype = data[c+14:c1]
		
		if ctype == "text/plain":
			html = False
		elif ctype == "text/html":
			html = True
		else:
			print "Unknown Content-Type: " + ctype
			html = False
		'''
		c = body.find("<hr>")
		c = body.find("<hr>", c+1)
		body = "<html> <body>" + body[c+4:]
		
		body = self.xmlize_html(body)		
				
		# *sigh* Oh google, you bitches.  Close your tags!!
		c = 0
		stack = []
		
		while c != -1:
			c = body.find("<", c) + 1
			if c == 0:
				break
			cend = body.find(">", c)
			c1 = c
			
			while True:
				c1 = body.find("=", c1)
				
				if c1 > cend or c1 == -1:
					break
					
				for i in range(10):
					if body[c1-i] == " ":
						break
				if i == 9:
					c1 += 1
					continue
					
				if body[c1+1] == "\"" or body[c1+1] == "'":
					c1 += 1
					continue
					
				c2 = body.find(" ", c1)
				if c2 > cend:
					c2 = cend
					
				body = body[:c1+1] + "\"" + body[c1+1:c2] + "\"" + body[c2:]
				cend += 2
				c1 = c2
				
				
			if body[c:c+2] == "tr":
				stack.append("tr")
			elif body[c:c+2] == "td":
				stack.append("td")
			elif body[c:c+5] == "table":
				stack.append("table")
			elif body[c:c+3] == "/tr":
				if stack.pop() != "tr":
					print "SHIT!"
			elif body[c:c+3] == "/td":
				if stack.pop() != "td":
					print "SHIT!"
			elif body[c:c+6] == "/table":
				body1 = body[:c-1]
				body2 = body[c-1:]
				while len(stack):
					d = stack.pop()
					if d == "td":
						body1 += "</td>"
					elif d == "tr":
						body1 += "</tr>"
					elif d == "table":
						break
				body = body1 + body2
				c = len(body1)+2
		
				
		return body.replace("\n", " ") + "\n"
			
		
			
		
			
		
	def download_all_emails(self, account):
		self.thread_lock.acquire()	
	
		d = False
		while not d:
			d = True		
			for i in self.messages_unread:
				if i["account"] != account["name"]:
					continue
				if i["pdata"] is None:
					d = False
					self.thread_lock.release()
					i["pdata"] = self.download_email(account, i)
					self.thread_lock.acquire()
					break
			
			
		self.thread_lock.release()


	def make_tooltip(self):
		lcnt = {}		
		for i in self.messages_unread:
			if not i["marked"]:
				if self.num_used() == 1:
					tmp = i["data"]["label"]
				else:
					tmp = i["account"]
					
				if tmp in lcnt:
					lcnt[tmp] += 1
				else:
					lcnt[tmp] = 1
		tmp = ""
		for i in lcnt.items():
			if tmp != "":
				tmp += "\n"
			tmp += i[0]
			tmp += ": " + str(i[1])
		if tmp == "":
			return _("No new emails.")
		return tmp


	def mark_all_read(self, widget, data=None):
		self.thread_lock.acquire()

		for m in self.messages_unread:
			for i in GMain._accounts:
				if i["name"] == m["account"]:
					account = i
					break

			if account["type"] == "Apps":
				base_url = "https://mail.google.com/a/" + account["domain"]
			else:
				base_url = "https://mail.google.com/mail"
			
			thr_id = m["data"]["thr_id"]

			self.send_post_mark(account, base_url + "/m/543241/?p=1.1&t=" + thr_id + "&bu=rd&at=" + account["gmail_at"], m)
	
		self.thread_lock.release()


	def add_menu_items(self, menu):
		GIcon.GIcon.add_menu_items(self, menu)
		menuItem = gtk.MenuItem(_("Mark all Read"))
		menuItem.connect("activate", self.mark_all_read)
		menu.append(menuItem)
		menuItem = gtk.MenuItem(_("Compose Email"))
		menuItem.connect("activate", self.compose_email2, None)
		menu.append(menuItem)

	def icon_stop(self):
		self.unbind_hotkey("open_gmail")
		self.unbind_hotkey("compose_email")

	def icon_start(self):
		self.got_cookies = {}
		self.bind_hotkey("open_gmail", self.browser_open, self.url)
		self.bind_hotkey("compose_email", self.compose_email, None)

	def __init__(self):
		self.got_cookies = {}
		self.gmail_at = {}
		self.config = "gmail"
		self.body_timer = -1
		self.popup_body_window = None
		
		GIcon.GIcon.__init__(self)
	
