# -*- coding: utf-8 -*-

import googsystray
import gtk,gobject
import sys, os, getopt
import signal
import shutil
import urllib
import urllib2
import webbrowser
import threading
import socket
import re
import copy
import types
import time
import urllib
import traceback



_GMain = None
_GConf = None
_GIPC = None
_hwnd = 0

_accounts = []





if os.name == "nt":
	from _winreg import *
	from ctypes import *


	_user32 = windll.user32
	_kernel32 = windll.kernel32

	class POINT(Structure):
		_fields_ = [("x", c_long),
			    ("y", c_long)]

	class MSG(Structure):
		_fields_ = [("hWnd", c_ulong),
			    ("message", c_uint),
			    ("wParam", c_ulong),
			    ("lParam", c_ulong),
			    ("time", c_ulong),
			    ("pt", POINT)]
			    
	def PeekMessage():
		msg = MSG()
		if _user32.PeekMessageW(byref(msg), None, 0, 0, 1) == 0:
			return None
		return msg
	W32_MOD_ALT = 0x1
	W32_MOD_CONTROL = 0x2
	W32_MOD_SHIFT = 0x4
	W32_MOD_SUPER = 0x8
	WM_USER = 0x400
	_hkeyId = 1

	class w32KeyThread:
	
		def w32BindKey(self, keyId, key, modifiers):
			newmod = 0;
			if modifiers & MOD_SHIFT:
				newmod = newmod | W32_MOD_SHIFT
			if modifiers & MOD_ALT:
				newmod = newmod | W32_MOD_ALT
			if modifiers & MOD_CONTROL:
				newmod = newmod | W32_MOD_CONTROL
			if modifiers & MOD_SUPER:
				newmod = newmod | W32_MOD_SUPER

			while self._w32BindData is not None:
				time.sleep(0.1)

			self._w32Lock.acquire()
		
			self._w32BindData = (keyId, key, newmod)

			_user32.PostThreadMessageW(self.thread.ident, WM_USER, None, None)
			
			self._w32Lock.release()
	
		def w32UnbindKey(self, keyId):

			while self._w32UnbindData is not None:
				time.sleep(0.1)

			self._w32Lock.acquire()

			self._w32UnbindData = keyId
			_user32.PostThreadMessageW(self.thread.ident, WM_USER, None, None)
		
			self._w32Lock.release()
			return
		
		def _w32KeyThread(self, args=None):
			global _GMain
			# Create the message queue
		  
			msg = MSG()
			_user32.PeekMessageW(byref(msg), None, WM_USER, WM_USER, 0)

			self.initialized = True
			while(True):
				_user32.WaitMessage()


				self._w32Lock.acquire()

				if self._w32BindData != None:
					(keyid, key, mod) = self._w32BindData
					vk=0
					if len(key) == 1:
						vk = ord(key[0])
					elif key[0] == "F":
						vk = 0x6F + int(key[1:])

					if vk != 0:
						_user32.RegisterHotKey(None, keyid, mod, vk)
					else:
						print "Keybinding of " + key + " failed!"
					self._w32BindData = None
					
				if self._w32UnbindData != None:
					_user32.UnregisterHotKey(None, self._w32UnbindData)
					self._w32UnbindData = None
					
				msg = PeekMessage()
				if msg != None:
					if msg.message != WM_USER:
						gobject.idle_add(_GMain.w32_hotkey_pressed, msg.wParam)
		
				self._w32Lock.release()


		def __init__ (self):
			self._w32Lock = threading.Lock()
			self._w32BindData = None
			self._w32UnbindData = None
			self._w32Message = None
			self.initialized = False

			self._w32Lock.acquire()
			self.thread = threading.Thread(target=self._w32KeyThread)
			self.thread.start()
			self._w32Lock.release()
			while not self.initialized:
				time.sleep(0.1)
	
				
	
else:
	from Xlib import X, display, XK

#SERVICE_ADD
import GIcon
import GConf
import GV
import GReader
import GMail
import GCal
import GContacts
import GIPC
import GWave
import GKeyring
import GNotification
import GDocs

MOD_SHIFT = 0x1
MOD_CONTROL = 0x4
MOD_ALT = 0x8
MOD_SUPER = 0x40
MOD_NUMLOCK = 0x10

firstRun = False


def fixWebBrowser():
	# *sigh* webbrowser is totally broken.  The user's BROWSER
	# variable only works if webbrowser already KNOWS about the
	# browser in question.  What's worse is that the BROWSER 
	# variable only gets checked on import, so register() just
	# sticks the new one at the end, so it'll never get called.
	# So we have to duplicate the BROWSER code as well.
	# This shouldn't matter for folks using Gnome or KDE, but
	# webbrowser won't check for xdg-open for xfce.
	for browser in ("chrome", "chromium",
			"chrome-browser", "chromium-browser",
			"xdg-open"):
		if webbrowser._iscommand(browser):
			webbrowser.register(browser, None, webbrowser.BackgroundBrowser(browser))
	if "BROWSER" in os.environ:
		_userchoices = os.environ["BROWSER"].split(os.pathsep)
		_userchoices.reverse()

		# Treat choices in same way as if passed into get() but do register
		# and prepend to _tryorder
		for cmdline in _userchoices:
			if cmdline != '':
				webbrowser._synthesize(cmdline, -1)
		cmdline = None # to make del work if _userchoices was empty
		del cmdline
		del _userchoices

		
#SERVICE_ADD
_services = [
		{
			"service": "gmail",
			"shortname": "Mail",
			"longname": _("Google Mail"),
			"url": "http://www.gmail.com",
			"apps_url": "http://mail.google.com/a/%(domain)s",
			"apps": True,
			"toggle_num": 2,
			"default_not": GConf.default_gmail_notification,
			"class": None,
			"classtype": GMail.GMail,
		},
		{
			"service": "gv",
			"shortname": "Voice",
			"longname": _("Google Voice"),
			"url": "http://voice.google.com",
			"apps": False,
			"toggle_num": 3,
			"default_not": GConf.default_gv_notification,
			"class": None,
			"classtype": GV.GV,
		},
		{
			"service": "gcal",
			"shortname": "Calendar",
			"longname": _("Google Calendar"),
			"url": "http://www.google.com/calendar/render",
			"apps_url": "http://www.google.com/calendar/hosted/%(domain)s",
			"apps": True,
			"toggle_num": 4,
			"default_not": GConf.default_gcal_notification,
			"class": None,
			"classtype": GCal.GCal,
		},
		{
			"service": "greader",
			"shortname": "Reader",
			"longname": _("Google Reader"),
			"url": "http://www.google.com/reader/view/",
			"apps": False,
			"toggle_num": 5,
			"default_not": GConf.default_greader_notification,
			"class": None,
			"classtype": GReader.GReader,
		},
		{
			"service": "gwave",
			"shortname": "Wave",
			"longname": _("Google Wave"),
			"url": "http://wave.google.com",
			"apps": False,
			"toggle_num": 6,
			"default_not": GConf.default_gwave_notification,
			"class": None,
			"classtype": GWave.GWave,
		},
		{
			"service": "gdocs",
			"shortname": "Docs",
			"longname": _("Google Docs"),
			"url": "http://docs.google.com",
			"apps_url": "http://docs.google.com/a/%(domain)s",
			"apps": True,
			"toggle_num": 7,
			"default_not": GConf.default_gdocs_notification,
			"class": None,
			"classtype": GDocs.GDocs,
		},
	]


def stop_services():
	# Windows is retarded, and the icons will remain visible
	# in the tray after quit, until you run the mouse pointer
	# across them.  Weird.  We'll just hide everything before
	# we quit then.
	_GMain.staticon.set_visible(False)
	
	for i in _services:
		if not googsystray.get_installed():			 
			print "Stopping " + i["service"]

		i["class"].stop()
		if i["class"].staticon is not None:
			i["class"].staticon.set_visible(False)
			
	for i in _accounts:
		i["contacts"].stop()
		
	GNotification.stop()

	return

_in_exc = False

def exc_handler(exc, val, tb):
#	stop_services()
	global _in_exc
	if _in_exc:
		return
	_in_exc = True
	
	for i in _services:
		i["class"].thread_run = False
			
	for i in _accounts:
		i["contacts"].thread_run = False

	if exc != KeyboardInterrupt:
		l = traceback.format_exception(exc, val, tb)
		str = ""
		for i in l:
			str += i

		error_dlg = gtk.Dialog(_("Googsystray error."), None, gtk.DIALOG_MODAL, 
			buttons = (gtk.STOCK_OK, gtk.RESPONSE_OK))
		error_dlg.set_default_response(gtk.RESPONSE_OK)
		label1 = gtk.Label()
		label1.set_markup(_("<b>Googsystray has experienced an error.  Please file a bug report at http://googsystray.sf.net, attaching the following stack trace:</b>"))
		label1.set_line_wrap(True)
		label2 = gtk.Label(str)
		label2.set_selectable(True)
		
		error_dlg.vbox.pack_start(label1, False, False, 5)
		error_dlg.vbox.pack_start(label2, False, False, 5)
			
		error_dlg.show_all()
		error_dlg.run()
		error_dlg.destroy()		
	
	for i in _services:
		if i["class"].staticon is not None:
			i["class"].staticon.set_visible(False)
	
	sys.exit(-1)
       
if googsystray.get_installed():			 
	sys.excepthook = exc_handler


	
class GMain(GIcon.GIcon):

	def close_config(self, saved):
		if (saved):
			self.set_autostart(self.autostart_button.get_active())

	def set_autostart(self, autostart=True):
		# This is broken if the software is not
		# 'installed' -- or running w/o py2exe on Windows
		# I'm okay with that -- I only intend to support
		# the .exe I distribute on SF.
		
		# Fixme though -- this only works correctly on a *nix
		# box if the desktop icon is installed in 
		# /usr/share/applications/ I believe it's a standard, but
		# I am not sure.  I should probably actually write it here
		# directly, but that's a hack too.  
			
		if os.name == "nt":
			regpath="Software\\Microsoft\\Windows\\CurrentVersion\\Run"
			reg = OpenKey(HKEY_CURRENT_USER, regpath, 0, KEY_WRITE)
			if autostart:
				SetValueEx(reg, "googsystray", 0, REG_SZ, os.path.join(googsystray.BASE_DIR, "googsystray.exe"))
			else:
				# We don't really have to give a crap here if it fails
				try:
					DeleteValue(reg, "googsystray")
				except:
					pass
			CloseKey(reg)
		elif os.name == "posix":
			if autostart:
				try:
					# FIXME this is broken on some desktops.  We should probably be creating a new
					# one from scratch, but I'm not a big fan of that either... Hrm.
					shutil.copy("/usr/share/applications/googsystray.desktop", 
						os.path.join(os.getenv("HOME"), ".config/autostart/googsystray.desktop"))
				except:
					print("Problem copying desktop file")
			else:
				try:
					os.remove(os.path.join(os.getenv("HOME"), ".config/autostart/googsystray.desktop"))
				except:
					pass
			
		return False

	def get_autostart(self):
		if os.name == "nt":
			regpath="Software\\Microsoft\\Windows\\CurrentVersion\\Run"
			reg = OpenKey(HKEY_CURRENT_USER, regpath)
			try:
				# We don't rightly care what the value is
				QueryValueEx(reg, "googsystray")
				CloseKey(reg)
				return True
			except:
				CloseKey(reg)
				return False
		elif os.name == "posix":
			return os.path.exists(os.path.join(os.getenv("HOME"), ".config/autostart/googsystray.desktop"))
		return False

	def toggle_service(self, cell, path, data=None):
		(model,serv) = data
		service = self.get_service(serv)
		sname = service["service"]
		
		if model[path][1] == "Apps" and not service["apps"]:
			error_dlg = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, _("This service does not support Google Apps accounts."))
			error_dlg.run()
			error_dlg.destroy()			
			return
		
		model[path][service["toggle_num"]] = not model[path][service["toggle_num"]]
		for i in _GConf.backupconfig["global"]["accounts"].items():
			if i[0] == model[path][0]:
				i[1]["services"][sname] = model[path][service["toggle_num"]]
					
		
		service["class"].set_sensitives()
		service["class"].update_notification_buttons()
		
		return True

	def add_toggle(self, tv, service):
		global _services
		if service["toggle_num"] < 0:
			return
		cell = gtk.CellRendererToggle()
		cell.activatable = True
		cell.connect("toggled", self.toggle_service, (tv.get_model(),service["service"]))
		col =  gtk.TreeViewColumn(service["shortname"], cell)
		col.add_attribute(cell, 'active', service["toggle_num"])
		tv.append_column(col)
		
	def add_account(self, widget, tv):
		model = tv.get_model()
		
		new_name = _("New")
		c = 1
		found = False
		
		while True:
			for a in _GConf.backupconfig["global"]["accounts"].items():
				if a[0] == new_name:
					new_name = _("New") + str(c)
					c += 1
					found = True
					break
			if not found:
				break
			found = False

		data = copy.deepcopy(GConf.default_account)
		_GConf.backupconfig["global"]["accounts"][new_name] = data 

		global _services

		arr = [new_name, data["type"]]
		for j in _services:
			arr.append(data["services"][j["service"]])
		iter = model.append(arr)
		tv.get_selection().select_iter(iter)
				  
		for i in _services:
			dnot = copy.deepcopy(i["default_not"])
			
			
			if type(dnot) == types.ListType:
				for j in dnot:
					j["account"] = new_name
					_GConf.backupconfig[i["service"]]["sub_notifications"].append(j)
			else:
				dnot["account"] = new_name
				_GConf.backupconfig[i["service"]]["sub_notifications"].append(dnot)
			i["class"].update_notification_buttons()
			i["class"].set_sensitives()
			
		self.edit_account(widget, tv)
		return True
		
	def edit_account(self, widget, tv):
		(model, rows) = tv.get_selection().get_selected_rows()
		types = ["Google", "Apps"]

		if len(rows) == 0:
			return True
			
		for a in _GConf.backupconfig["global"]["accounts"].items():
			if a[0] == model[rows[0]][0]:
				break
				
		name = a[0]
		data = a[1]
		
		if not name:
			print "ERROR!  No name!  Shouldn't get here!"
			
		newname = False

		while True:			
			(username, password) = GKeyring.get_creds(a[0], True)
		
			edit_dlg = gtk.Dialog(_("Edit Google Account"), None, 0, buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
					      gtk.STOCK_OK, gtk.RESPONSE_OK))
			edit_dlg.set_default_response(gtk.RESPONSE_OK)

			if newname:
				label = gtk.Label(_("Identifier already used."))
				edit_dlg.vbox.pack_start(label, False, False, 5)
			
			hbox = gtk.HBox()
			label = gtk.Label(_("Account name:"))
			name_entry = gtk.Entry()
			name_entry.set_visibility(True)
			name_entry.set_text(name)
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(name_entry, False, False, 5)
			edit_dlg.vbox.pack_start(hbox, False, False, 5)
			
			hbox = gtk.HBox()
			label = gtk.Label(_("Account type:"))
			type_combo = gtk.combo_box_new_text()
			c=0
			for i in types:
				type_combo.append_text(i)
				if i == data["type"]:
					type_combo.set_active(c)
				c+=1
			
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(type_combo, False, False, 5)
			edit_dlg.vbox.pack_start(hbox, False, False, 5)

			hbox = gtk.HBox()
			label = gtk.Label(_("Username:"))
			user_entry = gtk.Entry()
			user_entry.set_visibility(True)
			if username is not None:
				user_entry.set_text(username)
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(user_entry, False, False, 5)
			edit_dlg.vbox.pack_start(hbox, False, False, 5)

			hbox = gtk.HBox()
			label = gtk.Label(_("Password:"))
			pw_entry = gtk.Entry()
			pw_entry.set_visibility(False)
			if password is not None:
				pw_entry.set_text(password)
			pw_entry.set_activates_default(True)
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(pw_entry, False, False, 5)
			edit_dlg.vbox.pack_start(hbox, False, False, 5)
			
			if username is None or len(username) == 0:
				user_entry.grab_focus()
			else:
				pw_entry.grab_focus()

			edit_dlg.vbox.show_all()
			ret = edit_dlg.run()
			
			if ret == gtk.RESPONSE_REJECT:
				edit_dlg.destroy()
				return True
			
			username = user_entry.get_text()
			password = pw_entry.get_text()
			new_name = name_entry.get_text()
			
			type = types[type_combo.get_active()]
			edit_dlg.destroy()
			
			if a[0] != new_name:
				c = 0
				for n in _GConf.backupconfig["global"]["accounts"].items():
					if n[0] == new_name:
						c += 1

				if c != 0:
					newname = True
					continue
				
				
				_GConf.backupconfig["global"]["accounts"][new_name] = _GConf.backupconfig["global"]["accounts"].pop(a[0])
				data = _GConf.backupconfig["global"]["accounts"][new_name]
				model[rows[0]][0] = new_name

				global _services
				for i in _services:
					for j in _GConf.backupconfig[i["service"]]["sub_notifications"]:
						if j["account"] == a[0]:
							j["account"] = new_name
					i["class"].update_notification_buttons()
					
		
			GKeyring.set_creds(new_name, username, password, True)
			data["type"] = type
			
			model[rows[0]][1] = type
			
			if type == "Apps":
				for i in _services:
					if not i["apps"]:
						model[rows[0]][i["toggle_num"]] = False
						for j in _GConf.backupconfig["global"]["accounts"].items():
							if j[0] == model[rows[0]][0]:
								j[1]["services"][i["service"]] = False
						
					i["class"].update_notification_buttons()
					i["class"].set_sensitives()

			
			break
							
		return True
		
	def del_account(self, widget, tv):
		(model, rows) = tv.get_selection().get_selected_rows()
		(_, iter) = tv.get_selection().get_selected()
		
		if len(rows) == 0:
			return True
		
		name = model[rows[0]][0]
		print model[rows[0]]
			
		model.remove(iter)
			
		print _GConf.backupconfig["global"]["accounts"]
		del _GConf.backupconfig["global"]["accounts"][name]

		return True
		
	def browser_toggle(self, widget, data=None):
		global _GConf
		_GConf.backupconfig[self.config]["browser_action"] = data

	def draw_config(self, vbox):
		global _GConf
		hbox = gtk.HBox()
		vbox.pack_start(hbox, False, False, 2)
		
		label = gtk.Label(_("Accounts:"))
		hbox.pack_start(label, False, False, 2)

		# Yes, this code is a little wonky, but this way we don't have to 
		# edit here when adding a new service in the future.
		args = [str, str]
		for j in _services:
			args.append(bool)
		ls = gtk.ListStore(*args)
		for name, adata in _GConf.backupconfig["global"]["accounts"].iteritems():
			data = [name.encode("utf-8"), adata["type"]]
			for j in _services:
				data.append(adata["services"][j["service"]])
			ls.append(data)
		
		tv = gtk.TreeView(ls)
		tv.get_selection().set_mode(gtk.SELECTION_SINGLE)

		cell = gtk.CellRendererText()
		col = gtk.TreeViewColumn(_("Account Name"), cell)
		col.add_attribute(cell, 'text', 0)
		col.set_expand(True)
		tv.append_column(col)

		cell = gtk.CellRendererText()
		col = gtk.TreeViewColumn(_("Type"), cell)
		col.add_attribute(cell, 'text', 1)
		tv.append_column(col)

		for i in _services:
			self.add_toggle(tv, i)

	
		hbox.pack_start(tv, True, True, 2)
		
		vbox2 = gtk.VBox()
		hbox.pack_start(vbox2, False, False, 2)
		button = gtk.Button(None, gtk.STOCK_ADD)
		button.connect("clicked", self.add_account, tv)
		vbox2.pack_start(button, False, False, 2)
		button = gtk.Button(None, gtk.STOCK_EDIT)
		button.connect("clicked", self.edit_account, tv)
		vbox2.pack_start(button, False, False, 2)
		button = gtk.Button(None, gtk.STOCK_DELETE)
		vbox2.pack_start(button, False, False, 2)
		button.connect("clicked", self.del_account, tv)
		
		self.autostart_button = gtk.CheckButton(_("Automatically start on login"))
		self.autostart_button.set_tooltip_text(_("Sets googsystray to automatically start up when your user logs in"))
		self.autostart_button.set_active(self.get_autostart())
		vbox.pack_start(self.autostart_button, False, False, 2)

		GIcon.GIcon.draw_config(self,vbox)

		frame = gtk.Frame(_("On Browser Open"))
		vbox.pack_start(frame, False, False, 2)
		vbox1 = gtk.VBox()
		frame.add(vbox1)



		cmd_entry = gtk.Entry()
		if _GConf.backupconfig[self.config]["browser_cmd"] != None: 
			cmd_entry.set_text(_GConf.backupconfig[self.config]["browser_cmd"])
		cmd_entry.set_data("set_dict", _GConf.backupconfig[self.config])
		cmd_entry.set_data("dict_entry", "browser_cmd")
		self.entries.append(cmd_entry)
		
		radio_button = gtk.RadioButton(None, _("Open URL in browser"))
		radio_button.connect("toggled", self.browser_toggle, googsystray.ONCLICK_OPEN)
		vbox1.pack_start(radio_button, False, False, 2)
		if (_GConf.backupconfig[self.config]["browser_action"] == googsystray.ONCLICK_OPEN):
			radio_button.set_active(True)
		hbox = gtk.HBox()
		radio_button = gtk.RadioButton(radio_button, _("Open URL in new window"))
		radio_button.connect("toggled", self.browser_toggle, googsystray.ONCLICK_NEW_WINDOW)
		vbox1.pack_start(hbox, False, False, 2)
		if (_GConf.backupconfig[self.config]["browser_action"] == googsystray.ONCLICK_NEW_WINDOW):
			radio_button.set_active(True)
		
		hbox.pack_start(radio_button, False, False, 2)
		radio_button = gtk.RadioButton(radio_button, _("Open URL in new tab"))
		radio_button.connect("toggled", self.browser_toggle, googsystray.ONCLICK_NEW_TAB)
		vbox1.pack_start(radio_button, False, False, 2)
		if (_GConf.backupconfig[self.config]["browser_action"] == googsystray.ONCLICK_NEW_TAB):
			radio_button.set_active(True)

		hbox = gtk.HBox()
		radio_button = gtk.RadioButton(radio_button, _("Run command ('%s' for URL)"))
		radio_button.connect("toggled", self.browser_toggle, googsystray.ONCLICK_OTHER)
		radio_button.set_data("browser_entry", cmd_entry)
		vbox1.pack_start(hbox, False, False, 2)
		hbox.pack_start(radio_button, False, False, 2)
		hbox.pack_start(cmd_entry, True, True, 2)
		if (_GConf.backupconfig[self.config]["browser_action"] == googsystray.ONCLICK_OTHER):
			radio_button.set_active(True)
		


	
	def GoogleLogin(self, account, incorrect=False):
		adata = {}

		adata["cproc"] = urllib2.HTTPCookieProcessor()
#		adata["opener"] = urllib2.build_opener(urllib2.HTTPSHandler(debuglevel=10), adata["cproc"])
		adata["opener"] = urllib2.build_opener(adata["cproc"])
		
		adata["name"] = account[0]
		(adata["username"], adata["password"]) = GKeyring.get_creds(adata["name"])
		adata["services"] = account[1]["services"]
		adata["type"] = account[1]["type"]
		
		if (adata["password"] is None or len(adata["password"]) == 0 or
		    adata["username"] is None or len(adata["username"]) == 0 or
		    adata["username"] == "KEYRING" or adata["password"] == "KEYRING" or
		    incorrect):
			pass_dlg = gtk.Dialog(_("Googsystray Login"), None, 0, buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
					      gtk.STOCK_OK, gtk.RESPONSE_OK))
			pass_dlg.set_default_response(gtk.RESPONSE_OK)

			if not incorrect:
				label = gtk.Label(_("No username/password found."))
				pass_dlg.vbox.pack_start(label, False, False, 5)
			else:
				label = gtk.Label(_("Invalid username/password."))
				pass_dlg.vbox.pack_start(label, False, False, 5)
				
			label = gtk.Label(_("Account: ") + adata["name"])
			pass_dlg.vbox.pack_start(label, False, False, 5)

			hbox = gtk.HBox()
			label = gtk.Label(_("Username:"))
			user_entry = gtk.Entry()
			user_entry.set_visibility(True)
			if adata["username"] is not None:
				user_entry.set_text(adata["username"])
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(user_entry, False, False, 5)
			pass_dlg.vbox.pack_start(hbox, False, False, 5)

			
			hbox = gtk.HBox()
			label = gtk.Label(_("Password:"))
			pw_entry = gtk.Entry()
			pw_entry.set_visibility(False)
			pw_entry.set_activates_default(True)
			if adata["password"] is not None:
				pw_entry.set_text(adata["password"])
			hbox.pack_start(label, False, False, 5)
			hbox.pack_start(pw_entry, False, False, 5)
			pass_dlg.vbox.pack_start(hbox, False, False, 5)
			
			r_cbutton = gtk.CheckButton(_("Remember my username/password?"))
			pass_dlg.vbox.pack_start(r_cbutton, False, False, 5)
			
			if adata["username"] is None or len(adata["username"]) == 0:
				user_entry.grab_focus()
			else:
				pw_entry.grab_focus()

			pass_dlg.vbox.show_all()
			ret = pass_dlg.run()

			if ret == gtk.RESPONSE_REJECT:
				pass_dlg.destroy()
				return
			
			adata["username"] = user_entry.get_text()
			adata["password"] = pw_entry.get_text()
			if r_cbutton.get_active():
				GKeyring.set_creds(adata["name"], adata["username"], adata["password"])
			global _GConf
			_GConf.save_config()
			
					
			pass_dlg.destroy()
			
		
		
		if adata["type"] == "Google":
			login_url = "https://www.google.com/accounts/ServiceLogin"
			auth_url = "https://www.google.com/accounts/ServiceLoginAuth"
			username = adata["username"]
			adata["domain"] = None
		else:
			c = adata["username"].find("@")
			adata["domain"] = adata["username"][c+1:]
			username = adata["username"][:c]
			adata["dom_username"] = username
			login_url = "https://www.google.com/a/" + adata["domain"] + "/ServiceLogin"
			auth_url = "https://www.google.com/a/" + adata["domain"] + "/LoginAction2"

		while True:
			try:
				f = adata["opener"].open(login_url)
				data = f.read()
				galx_match_obj = re.search(r'name="GALX"\s*value="([^"]+)"', data, re.IGNORECASE)
				galx_value = galx_match_obj.group(1) if galx_match_obj.group(1) is not None else ''
				params = urllib.urlencode({'Email':username,
							   'Passwd':adata["password"],
							   'GALX':galx_value})
			
				print username
				print adata["password"]		   
				f = adata["opener"].open(auth_url, params)
				
				data = f.read()
				
				c = data.find("Sign in to")
				if c != -1:
					self.GoogleLogin(account, True)
					return
				
				c = data.find("incorrect")
				if c != -1:
					self.GoogleLogin(account, True)
					return
					
				break
			except Exception, e:
				for i in range(500):
					while gtk.events_pending():
						gtk.main_iteration(False)
					time.sleep(0.01)


		adata["contacts"] = GContacts.GContacts()
		global _accounts
		
		cnt = 0
		for i in _accounts:
			if i["name"] == adata["name"]:
				i["contacts"].stop()
				del _accounts[cnt]
				break
			cnt += 1
		_accounts.append(adata)

		adata["contacts"].set_account(adata)		
		adata["contacts"].start()
		
		
	def w32_hotkey_pressed(self, keyid):
		for i in self.hotkeys:
			if i["hkeyid"] == keyid:
				if i["data"] is not None:
					i["function"](i["data"])
				else:
					i["function"]()
		return False
		
	def bindKey(self, key, modifiers, function, data):
		if os.name == "nt":
			global _hkeyId
			_hkeyId += 1
				
			self.keyThread.w32BindKey(_hkeyId, key, modifiers)
			self.hotkeys.append({"key":key, "modifier":modifiers, "function":function, "hkeyid":_hkeyId, "data":data})
		else:
			keycode = self.display.keysym_to_keycode(XK.string_to_keysym(key))
			self.rootWin.grab_key(keycode, modifiers, 1, 
					      X.GrabModeAsync,
					      X.GrabModeAsync)
			self.rootWin.grab_key(keycode, modifiers | MOD_NUMLOCK, 1, 
					      X.GrabModeAsync,
					      X.GrabModeAsync)
			self.rootWin.display.flush()
			self.hotkeys.append({"key":keycode, "modifier":modifiers, "function":function, "data":data})
		return
		
	def unbindKey(self, key, modifiers):
		if os.name == "nt":
			for i in self.hotkeys:
				if i["key"] == key and i["modifier"] == modifiers:
					self.keyThread.w32UnbindKey(i["hkeyid"])
					self.hotkeys.remove(i)
					break
		else:
		
			keycode = self.display.keysym_to_keycode(XK.string_to_keysym(key))
			for i in self.hotkeys:
				if i["key"] == keycode and i["modifier"] == modifiers:
					self.hotkeys.remove(i)
					break
			self.rootWin.ungrab_key(keycode, modifiers)

		
	def hotkey_main_icon(self):
		if self.get_config()["always_show_icon"]:
			self.get_config()["always_show_icon"] = False
			if self.staticon.get_visible():
				self.staticon.set_visible(False)
		else:
			self.get_config()["always_show_icon"] = True
			self.staticon.set_visible(True)
			
		global _GConf
		_GConf.save_config()

		
	def stop(self):
		if self.staticon is not None:
			self.staticon.set_visible(False)

		global _accounts
		for i in _accounts:
			if "contacts" in i:
				i["contacts"].stop()
		
		_accounts = []
		
		if os.name == "posix" and self.xserver_id != -1:
			gobject.source_remove(self.xserver_id)
		self.unbind_hotkey("show_main_icon")

		GNotification.stop()

		
	def start(self):
		for a in self.get_config()["accounts"].items():
			self.GoogleLogin(a)
			
		global _accounts
		if len(_accounts) == 0:
			sys.exit(0)

		if self.menu is not None:
			self.menu.destroy()
		self.menu = gtk.Menu();
		self.create_menu()
	
		if self.staticon == None:
			self.staticon = gtk.StatusIcon()
			self.staticon.set_from_file(os.path.join(googsystray.BASE_DIR, "icons", self.get_config()["icon"]))
			self.staticon.connect("activate", self.activate)
			self.staticon.connect("popup_menu", self.popup)

			
		if False and os.name == "nt":
                        import win32gui, win32api

			windows = []
                        win32gui.EnumThreadWindows(win32api.GetCurrentThreadId(), lambda hwnd, resultList: resultList.append(hwnd),windows)
                        for i in windows:
                                if win32gui.GetWindowText(i) == "":
                                        global _hwnd
                                        _hwnd = i
                                        
                GNotification.start()
	
		if self.get_config()["always_show_icon"]:
			self.staticon.set_visible(True)
		else:
			if self.staticon.get_visible():
				self.staticon.set_visible(False)


		if os.name == "nt" and self.keyThread is None:
			self.keyThread = w32KeyThread()

		if os.name == "posix":
			self.xserver_id = gobject.io_add_watch(self.rootWin.display, gobject.IO_IN, self.xserver_input)
			
		self.bind_hotkey("show_main_icon", self.hotkey_main_icon)
		
	def xserver_input(self,source,cond):
		while (self.display.pending_events() != 0):
			event = self.display.next_event()
			if event._code == X.KeyPress:
				event._data["state"] &= ~0x10
				for i in self.hotkeys:
					if (i["key"] == event._data["detail"] and 
					    i["modifier"] == event._data["state"]):
						if i["data"] is not None:
							i["function"](i["data"])
						else:
							i["function"]()
		return True
		

	def new_sms(self, widget, data=None):
		gv = self.get_service("gv")
		gv["class"].new_sms()
		
	def add_menu_items(self, menu):
		for i in _services:
			if not i["class"].am_used():
				continue
			menuItem = gtk.MenuItem("%(url)s" % {"url":i["longname"]})
			menu.append(menuItem)
			menu2 = gtk.Menu()
			menuItem.set_submenu(menu2)
			menu2.connect("motion-notify-event", self.test_motion)

			i["class"].add_menu_items(menu2)

		
		
	
	def __init__ (self):
		self.config = "global"
		self.url = None
		self.notification_timer = None
		self.keyThread = None
		self.xserver_id = -1
		
		GIcon.GIcon.__init__(self)
		
		
		self.hotkeys = []

		if os.name != "nt":
			self.display = display.Display()
			self.rootWin = self.display.screen().root
			self.rootWin.change_attributes(event_mask=X.KeyPressMask)


def main():
	global configOnly
	configOnly = False
	
	global _GMain, _GConf, _GIPC

	gtk.gdk.threads_init()
	gtk.gdk.threads_enter()
	
	_GConf = GConf.GConf()
	_GMain = GMain()
	
	for i in _services:
		i["class"] = i["classtype"]()
		i["class"].shortname = i["shortname"]
		i["class"].longname = i["longname"]
		i["class"].url = i["url"] 

	_GIPC = GIPC.GIPC()
	
	
	_GIPC.start_client()
	
	socket.setdefaulttimeout(30.0)
	
	try:
		opts,args = getopt.getopt(sys.argv[1:], "hdcm:", ["debug", "help", "config", "mail="])
	except getopt.error, msg:
		print msg
		print "Usage: TODO"
		sys.exit(2)
	for o, a in opts:
		if o in ("-h", "--help"):
			print "Usage: TODO"
			sys.exit(0)
		if o in ("-d", "--debug"):
			if _GIPC.is_client():
				_GIPC.debug_trace()
				sys.exit(0)
				return
		if o in ("-c", "--config"):
			if _GIPC.is_client():
				_GIPC.start_config()
				sys.exit(0)
				return			
			configOnly = True
			_GConf.open_config_window()
		if o in ("-m", "--mail"):
			if not _GIPC.is_client():
				print _("Googsystray is not running!")
				sys.exit(0)
				return
			_GIPC.send_mail(a)
			sys.exit(0)
			return

	fixWebBrowser()
	
			
	if not configOnly:
		if _GIPC.is_client():
			print _("An instance of googsystray is already running.")
			sys.exit(0)
			return
			
		global firstRun
		if firstRun:
			_GConf.open_config_window()
		else:
			_GMain.start()
			for i in _services:
				i["class"].start()

	_GIPC.start_server()
	try:
		gtk.main()
	except Exception, e:
		print "ERROR!!! BETTER HANDLING"
		print e
	gtk.gdk.threads_leave()


if __name__ == "__main__":
	start()
