# -*- coding: utf-8 -*-

import googsystray
import gtk
import gobject
import json
import os
import copy
import urllib


from xml.dom import minidom
from xml.etree import ElementTree as ET

import GIcon, GMain, GPopupWindow

class GV(GIcon.GIcon):
	def entry_changed(self, widget, label):	
		# sigh windows pygtk doesn't have get_text_length() fixme
		wlen = len(widget.get_text())
		
		if wlen < 161:
			label.set_markup("<span color=\"#80A0E0\">" + str(160-wlen) + "</span>")
		else:
			label.set_markup("<span color=\"#80A0E0\">" + str((wlen/160)+1) + "." + str(160-(wlen%160)) + "</span>")

		widget.editing_done()
		return True

	def entry_activate(self, widget, message):
		data = message["data"]

		for i in GMain._accounts:
			if i["name"] == message["account"]:
				account = i
				break


		params = urllib.urlencode(	{
							"_rnr_se":account["gv_data"]["_rnr_se"],
							"id":data["id"],
							"c":1,
							"smstext":widget.get_text(),
							"number":data["phoneNumber"],
						})

		widget.set_text(_("Sending SMS message"))
		widget.set_sensitive(False)
		self.send_post_mark(account, "https://www.google.com/voice/m/sendsms", message, params)
	
	def label_clicked(self, widget, event, data=None):
		label = widget.get_child()
		message = widget.get_data("message")


		if data == "sms":
			if label.get_label() == label.get_data("short_str"):
				label.set_markup(label.get_data("long_str"))

		if data == "markread":
			for i in GMain._accounts:
				if i["name"] == message["account"]:
					account = i
					break
			id = message["data"]["id"]
			label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Marking...")) + "</span>")
			self.send_post_mark(account, "https://www.google.com/voice/m/mark/?id=" + id + "&read=1", message)
			widget.set_sensitive(False)
			

	def draw_sms_label(self, label, message):
		label.set_justify(gtk.JUSTIFY_LEFT)
		label.set_line_wrap(True)

		long_str = ""
		short_str = ""
		count = 0
		skipcount = 0
		total = len(message["messages"])
		do_short = False
		if (total > 5):
			do_short = True
				
		for m in message["messages"]:
			if count == 0:
				message_line = ""
			else:
				message_line = "\n"
			message_line += "<b>" + m["from"] + "</b>"
			message_line += " " + self.fix_markup(m["text"])
			message_line += " <span color=\"#404040\">" + m["time"] + "</span>"
			long_str += message_line
			if not do_short or count == 0 or count > (total-3):
				if skipcount > 0:
					short_str += "\n<span color=\"#0000FF\">" + str(skipcount) + " " + _("more messages") + "</span>"
					skipcount = 0;
				short_str += message_line
			else:
				skipcount+=1
			
			count+=1
			
		entry = label.get_data("sms_entry")
		if entry != None:
			if not entry.get_property("sensitive"):
				entry.set_text("")
				entry.set_sensitive(True)
			
		label.set_data("sms_id", message["id"])
		label.set_data("short_str", short_str)
		label.set_data("long_str", long_str)
		label.set_markup(short_str)
		
		
	def draw_message(self, message):
		mvbox = self.popup_window.vbox
		
		vbox = gtk.VBox()
		mvbox.pack_start(vbox, False, False, 0)
		vbox.set_data("msg_id", message["id"])
		self.popup_messages.append(vbox)
		
		data = message["data"]
		
		frame = gtk.Frame()
		vbox1 = gtk.VBox()
		frame.add(vbox1)
		vbox.pack_end(frame, False, False, 3)


		hbox1 = gtk.HBox()

		try:
			pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.temp_dir, os.path.normpath(data["portrait"])))
		# Fallback to default pixmap just in case
		except:
			os.path.join(googsystray.temp_dir, os.path.normpath(data["portrait"]))
			pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.BASE_DIR, "icons", "Unknown-Portrait.png"))
			
		scaled_size = int(48 * GMain._GConf.gconfig["global"]["popup_size"])

		if pb.get_width() == scaled_size and pb.get_height() == scaled_size:
			image = gtk.image_new_from_pixbuf(pb)
		elif pb.get_height() == scaled_size or pb.get_width() == scaled_size:
			pb2 = gtk.gdk.Pixbuf(pb.get_colorspace(), pb.get_has_alpha(), pb.get_bits_per_sample(), scaled_size, scaled_size)
			pb2.fill(0xffffffff)
			pb.copy_area(0, 0, pb.get_width(), pb.get_height(), pb2, 0, 0)
			image = gtk.image_new_from_pixbuf(pb2)
		else:
			# pb.get_width() == pb.get_height():
			pb2 = pb.scale_simple(scaled_size, scaled_size, gtk.gdk.INTERP_HYPER)
			image = gtk.image_new_from_pixbuf(pb2)
			
		hbox1.pack_start(image, False, False, 5)
		
		
		label = gtk.Label()
		label_str = "<b>" + data["from_name"] + "</b>"
		if message.get("from_number") != None:
			label_str += "<span color=\"#404040\">  " + data["from_number"] + "</span>"
		label_str += "\n"

		label_str += data["time"]
		if message.get("from_number") != None:
			label_str += "<span color=\"#404040\">  " + data["reltime"] + "</span>"
		label_str += "\n"

		# I don't think this actually happens, ever
		if data["type"] == "missedcall":
			label_str += "<span color=\"#404040\"><b><i>Missed Call</i></b></span>"
		
		label.set_justify(gtk.JUSTIFY_LEFT)
				
		label.set_markup(label_str)
		hbox1.pack_start(label, False, False, 10)
		vbox2 = gtk.VBox()

		button=GIcon.link_label()
		if data["markedRead"]:
			button.set_markup("<span color=\"#800080\" underline=\"single\">" + (_("Unmark read")) + "</span>")
		else:
			button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Mark as read")) + "</span>")
		
		button.connect("button_press_event", self.label_clicked, "markread")
		button.set_data("message", message)
		vbox2.pack_start(button, False, False, 0)

		# Call and Delete support will wait until somebody wants
		# it.
		"""
		button=gtk.EventBox()
		label=gtk.Label()
		button.set_events(gtk.gdk.BUTTON_PRESS_MASK)
		button.set_visible_window(False)
		button.add(label)
		label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Call")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "call")
		button.set_data("message", message)
		vbox2.pack_start(button, False, False, 0)

		button=gtk.EventBox()
		label=gtk.Label()
		button.set_events(gtk.gdk.BUTTON_PRESS_MASK)
		button.set_visible_window(False)
		button.add(label)
		label.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Delete")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "delete")
		button.set_data("message", message)
		vbox2.pack_start(button, False, False, 0)
		"""

		hbox1.pack_end(vbox2, False, False, 10)
		vbox1.pack_start(hbox1, False, False, 4)
		
		if data["type"] == "voicemail":
			label = gtk.Label()
			label.set_justify(gtk.JUSTIFY_LEFT)
			label.set_line_wrap(True)
			label.set_selectable(True)
			label.set_markup(data["message"])
			#label.set_size_request(int(450 * self.get_gconfig()["popup_size"]), -1)
			vbox1.pack_start(label, False, True, 7)
		elif data["type"] == "sms":
			label = gtk.Label()
			align = gtk.Alignment(0.0, 1.0, 0.0, 1.0)
			
			self.draw_sms_label(label, data)
			vbox.set_data("label", label)
			#label.set_size_request(int(450 * self.get_gconfig()["popup_size"]), -1)
			eventbox = gtk.EventBox()
			eventbox.add(label)
			eventbox.set_events(gtk.gdk.BUTTON_PRESS_MASK)
			eventbox.set_visible_window(False)
			eventbox.connect("button_press_event", self.label_clicked, "sms")
			align.set_padding(0,0,5,0)
			align.add(eventbox)
			vbox1.pack_start(align, False, True, 7)
			hbox = gtk.HBox()
			entry = gtk.Entry()
			label.set_data("sms_entry", entry)
			label = gtk.Label()
			entry.connect("changed", self.entry_changed, label)
			entry.connect("activate", self.entry_activate, copy.deepcopy(message))
			self.entry_changed(entry, label)
			hbox.pack_start(entry, True, True, 7)
			hbox.pack_start(label, False, False, 7)
			vbox1.pack_start(hbox, False, False, 7)
		vbox.show_all()
		
	def update_popup(self): 
		self.thread_lock.acquire()
		
		for i in self.popup_messages:
			id = i.get_data("msg_id")
			c = id.find("!@#")
			real_id = id[:c]
			for j in self.messages_unread:
				c = j["id"].find("!@#")
				
				if j["id"] != id and j["id"][:c] == real_id:
					label = i.get_data("label")
					self.draw_sms_label(label, j["data"])
					i.set_data("msg_id", j["id"])
					break
			
		
		# Yay for reentrant locks.
		GIcon.GIcon.update_popup(self)
		
		self.thread_lock.release()

	def select_span(self, gc):
		if gc == "gc-word-high":
			return "<span color=\"#000000\">" 
		if gc == "gc-word-med1":
			return "<span color=\"#505050\">" 
		if gc == "gc-word-med2":
			return "<span color=\"#303030\">" 
		# haven't seen anything else so far
		return "<span color=\"#FF0000\">"

	def getAllData(self, e, info):
		if (e.get("class") == "gc-message-message-display" and info["type"] == "voicemail"):
			message = ""
			lastclass = ""
			for i in e.getchildren():
				if i.get("class") == lastclass:
					message += " " + i.text.strip()
					continue
				elif lastclass != "":
					message += "</span> "
				message += self.select_span(i.get("class"))
				message += i.text.strip()
				lastclass = i.get("class")
				
			message += "</span>"	
			info["message"] = message
		if (e.get("class") == "gc-message-sms-row"):
			message = {"from":"","text":"","time":""}
			for i in e.getchildren():
				if (i.get("class") == "gc-message-sms-from"):
					message["from"] = i.text.strip()
				if (i.get("class") == "gc-message-sms-text"):
					# cute, blank texts cause problems.
					if i.text is not None:
						message["text"] = i.text.strip()
					else:
						message["text"] = ""
				if (i.get("class") == "gc-message-sms-time"):
					message["time"] = i.text.strip()
	
			info["messages"].append(message)
			return
		if (e.get("class") == "gc-message-time-row"):
			for i in e.getchildren():
				if (i.get("class") == "gc-message-time"):
					info["time"] = i.text.strip()
				if (i.get("class") == "gc-message-relative"):
					info["reltime"] = i.text.strip()
	
			return
		if (e.get("class") == "gc-message-type"):
			info["from_number"] = e.text.strip()
		if (e.get("class") == "gc-message-location"):
			for i in e.getchildren():
				if i.get("class") == "gc-under":
					info["from_number"] = i.text.strip()
		if (e.get("class") == "gc-message-name"):
			for i in e.getchildren():
				if i.get("title") == "Go to contact":
					info["from_name"] = i.text.strip()
			if info.get("from_name") == None:
				for i in e.getchildren():
					if i.tag == "span":
						info["from_name"] = i.text.strip()
				
				
		if (e.get("class") == "gc-message-portrait"):
			for i in e.getchildren():
				if (i.get("src") != None):
					info["portrait"] = i.get("src")[1:]
					if info["portrait"][len(info["portrait"])-2:] == "32":
						info["portrait"] = info["portrait"][:len(info["portrait"])-6]
			return
		for i in e.getchildren():
			self.getAllData(i, info)

	
	
	def icon_check_data(self, account):
		new_messages = []
		
		if self.popup_window != None:
			self.fullCheck = True

		if "gv_data" not in account:
			account["gv_data"] = {}
			
		
		if "_rnr_se" not in account["gv_data"]:
			account["gv_data"]["_rnr_se"] = ""
			self.fullCheck = True
		# The mobile site doesn't give us as much information as we'd like, but it's
		# also only 4k, compared to the some 95k of the full xml.  So this is the one
		# we poll.
		#googsystray.debug("Checking GV")


		if not self.fullCheck or account["gv_data"]["_rnr_se"] == "":
			data = self.urlopen2(account, "https://www.google.com/voice/m/i")
			if data == None:
				#fixme indicate error
				
				self.merge_messages(account["name"], new_messages)
				return True

			data = self.strip_html(data)

			tree = ET.ElementTree(ET.XML(data))
			walkAll = tree.getiterator()
			unread = False
			dnd = False
			for i in walkAll:
				if i.get("href") == "/voice/m/disablednd":
					# NB: This is broken at the moment.
					# it _should_ work, but it's broken on Google's
					# side.  It won't update the bar at the top
					# when you refresh.  It's not broken on Firefox,
					# which I think is related to google changing the gv
					# cookie on every access for some reason...
					# But it's broken in Chrome and Lynx. 
					# Fixme: remove this note if google fixes their shit,
					# and also remove the workaround below.
					dnd = True
				if i.get("name") == "_rnr_se":
					account["gv_data"]["_rnr_se"] = i.get("value")
				if i.get("href") == "/voice/m/i/unread":
					unread = True
			
			
			
			
			data = self.urlopen2(account, "https://www.google.com/voice/m/donotdisturb")
			if data == None:
				#fixme indicate error
				self.merge_messages(account["name"], new_messages)
				return True

			data = self.strip_html(data)

			tree = ET.ElementTree(ET.XML(data))
			walkAll = tree.getiterator()
			for i in walkAll:
				if i.get("id") == "doNotDisturb":
					if i.get("checked") == "true":
						dnd = True
			
			account["gv_data"]["dnd"] = dnd
			gobject.idle_add(self.dnd_update, None)
			
			if not unread and not self.fullCheck:
				self.merge_messages(account["name"], new_messages)
				#googsystray.debug("Out, no data")
				return True
				

		if "phones" not in account["gv_data"]:
			data = self.urlopen2(account, 'https://www.google.com/voice/settings/tab/phones')
			if data == None:
				self.merge_messages(account["name"], new_messages)
				return True
			account["gv_data"]["phones"] = []
			xmldoc = minidom.parseString(data)
			node = xmldoc.firstChild.childNodes[1].childNodes[0]
			tmp = json.loads(node.data)
			account["gv_data"]["dnd"] = tmp["settings"]["doNotDisturb"]
			gobject.idle_add(self.dnd_update, None)
			for i in tmp["phones"].items():
				phone = {}
				phone["number"] = i[1]["phoneNumber"]
				phone["disp_number"] = i[1]["formattedNumber"]
				phone["name"] = i[1]["name"]
				if i[1]["type"] == 1:
					phone["type"] = "Home"
				elif i[1]["type"] == 2:
					phone["type"] = "Mobile"
				elif i[1]["type"] == 3:
					phone["type"] = "Work"
				elif i[1]["type"] == 7:
					phone["type"] = "Gizmo"
				else:
					phone["type"] = "Unknown Type " + str(phone["type"])
				phone["type_code"] = i[1]["type"]
				account["gv_data"]["phones"].append(phone)

	
		data = self.urlopen2(account, 'https://www.google.com/voice/inbox/recent/all/')
		if data == None:
			self.merge_messages(account["name"], new_messages)
			return True
		xmldoc = minidom.parseString(data)

		
		node = xmldoc.firstChild.childNodes[1].childNodes[0]
		tmp = json.loads(node.data)
		
		if tmp["unreadCounts"]["all"] == 0 and not self.fullCheck:
			self.merge_messages(account["name"], new_messages)
			return True

		node = xmldoc.firstChild.childNodes[3].firstChild
		data = node.data
		
		data = self.strip_html(data)
		
		tree = ET.XML("<root>"+data+"</root>")
		
	
		for j in tree.findall("div"):
			if (not "id" in j.attrib):
				continue
				
			info = {
				"id"		:	j.attrib["id"],
				"messages"	:	[],
				"markedRead"	:	tmp["messages"][j.attrib["id"]]["isRead"],
				"phoneNumber"	:	tmp["messages"][j.attrib["id"]]["phoneNumber"],
				}
			if "missed" in tmp["messages"][j.attrib["id"]]["labels"]:
				info["type"] = "missedcall"
			elif "sms" in tmp["messages"][j.attrib["id"]]["labels"]:
				info["type"] = "sms"
			elif "voicemail" in tmp["messages"][j.attrib["id"]]["labels"]:
				info["type"] = "voicemail"
			else:	# We can get PLACED calls here, and maybe others
				continue
			self.getAllData(j, info)

			if info["portrait"].startswith("s2/../"):
				info["portrait"] = info["portrait"][6:]

			if not info["markedRead"]:
				if info["type"] == "sms":
					title = _("New SMS from %(from)s") % { "from": info["from_name"] }
				elif info["type"] == "voicemail":
					title = _("New voicemail from %(from)s") % { "from": info["from_name"] }
				elif info["type"] == "missedcall":
					title = _("Missed call from %(from)s") % { "from": info["from_name"] }
					
				if len(info["messages"]) > 0:
					summary = info["messages"][len(info["messages"])-1]["text"]
				else:
					summary = ""
				
				new_messages.append(
				         {"id":info["id"]+info["phoneNumber"]+"!@#"+str(len(info["messages"])),
			                  "count":1,
					  "sub_id": info["type"],
					  "account": account["name"],
					  "title": title,
					  "summary": summary,
					  "icon": os.path.join(googsystray.temp_dir, os.path.normpath(info["portrait"])),
					  "marked": False,
					  "data": info,
					})
			

		for i in new_messages:
			portrait = os.path.join(googsystray.temp_dir, os.path.normpath(i["data"]["portrait"]))
			if not os.path.exists(portrait):
				data = self.urlopen2(account, "http://www.google.com/" + i["data"]["portrait"] + "?sz=48")
				if data == None:
					continue
				
				(pdir, pfile) = os.path.split(portrait)

				if not os.path.exists(pdir):
					os.makedirs(pdir)
				
				pf = open(portrait, "wb")
				pf.write(data)
				pf.close()
				

		self.fullCheck = False
		self.merge_messages(account["name"], new_messages)

		return True

	def new_sms_entry_activate(self, widget, acct):
		number = self.new_sms_entry.child.get_text()

		real_number = ""		
		if number[len(number)-1] == ")":
			c = len(number)-5
			while number[c:c+3] != " - ":
				if number[c].isdigit():
					real_number = number[c] + real_number
				if c == 0:
					break
				c-=1
				
			
		else:
			c = len(number)-1
			while c >= 0:
				if number[c].isdigit():
					real_number = number[c] + real_number
				c-=1

		params = urllib.urlencode(	{
							"_rnr_se":acct["gv_data"]["_rnr_se"],
							"c":1,
							"id":"",
							"smstext":self.new_sms_entry2.get_text(),
							"number":real_number,
						})

		self.new_sms_entry2.set_sensitive(False)
		self.new_sms_entry.set_sensitive(False)
		self.new_sms_button.set_sensitive(False)
		self.new_sms_button.set_label(_("Sending..."))
		self.send_post_block(acct, "https://www.google.com/voice/m/sendsms", params)
		self.new_sms_window.destroy()
		self.new_sms_window = None
		
		

	def new_sms_draw(self, account, vbox):
		hbox = gtk.HBox()
		
		label = gtk.Label("To:")
		hbox.pack_start(label, False, False, 2)
		entry = gtk.combo_box_entry_new_text()
		completion = gtk.EntryCompletion()
		liststore = gtk.ListStore(str)
		
		for acct in GMain._accounts:
			for i in acct["contacts"].phoneContacts:
				for j in i["phone"]:
					etext = i["title"] + " - " + j["number"] + " ("
					if j["type"] == "mobile":
						etext += "M)"
					elif j["type"] == "home":
						etext += "H)"
					else:
						etext += "O)"
					entry.append_text(etext)
					liststore.append([etext])

		completion.set_model(liststore)
		completion.set_text_column(0)
		entry.child.set_completion(completion)
		hbox.pack_start(entry, True, True, 2)
		vbox.pack_start(hbox, False, False, 2)
		
		label = gtk.Label("Message:")
		vbox.pack_start(label, False, False, 2)

		hbox = gtk.HBox()
		entry2 = gtk.Entry()
		vbox.pack_start(hbox, False, False, 2)
		hbox.pack_start(entry2, True, True, 2)
		label = gtk.Label("")
		label.set_markup("<span color=\"#80A0E0\">160</span>")
		hbox.pack_end(label, False, False, 2)
		
		
		
		hbox = gtk.HBox()
		button = gtk.Button(_("Send SMS"))
		hbox.pack_end(button, False, False, 5)
		vbox.pack_start(hbox, False, False, 5)
		# If I send entry, button, and entry2 as a triple in the data,
		# somehow they end up getting GC'd.  And so does the label.
		# I can't figure out why, as a reference to them would still 
		# be there as part of the children of the window
		# But if I don't pass those three vars as a triple... nothing
		# gets GC'd.  Weird.
		entry2.connect("changed", self.entry_changed, label)
		entry2.connect("activate", self.new_sms_entry_activate, account)
		button.connect("clicked", self.new_sms_entry_activate, account)
		self.new_sms_entry = entry
		self.new_sms_entry2 = entry2
		self.new_sms_button = button
		
		vbox.show_all()
		
		return

	def new_sms_destroy(self):
		self.new_sms_window = None
		return

	def new_sms(self, data1=None, data2=None):
		if self.new_sms_window != None:
			self.new_sms_window.destroy()
			self.new_sms_window = None
			return
			
			
		# FIXME we should probably actually support WHICH account to open...
		acct = None
		for i in GMain._accounts:
			if i["services"]["gv"]:
				acct = i
				break
		
		# Nothing, if no account is GV-enabled.  
		if acct is None:
			return 

		self.new_sms_window = GPopupWindow.get_new_popup_window(self.new_sms_destroy, 
		                                                        _("Send SMS Message"),
		                                                        icon=os.path.join(googsystray.BASE_DIR, "icons", self.get_config()["icon"]))
		                                                        
		self.new_sms_window.window.set_default_size(int(400*self.get_gconfig()["popup_size"]),-1)
		self.new_sms_draw(acct, self.new_sms_window.vbox)
		self.new_sms_window.show_all()

	def new_call_call(self, widget, cancel):
		number = self.new_call_call_to.child.get_text()

		real_number = ""		
		if number[len(number)-1] == ")":
			c = len(number)-5
			while number[c:c+3] != " - ":
				if number[c].isdigit():
					real_number = number[c] + real_number
				if c == 0:
					break
				c-=1
				
			
		else:
			c = len(number)-1
			while c >= 0:
				if number[c].isdigit():
					real_number = number[c] + real_number
				c-=1
				
		model = self.new_call_call_from.get_model()
		phone_from = model[self.new_call_call_from.get_active()][0]

		real_from = None
		for acct in GMain._accounts:
			try:
				for i in acct["gv_data"]["phones"]:
					etext = acct["name"] + " - " + i["name"] + " - " + i["disp_number"]
					if etext == phone_from:
						real_from = i
						break
			except KeyError:
				continue
				
			if real_from is not None:
				break
				
					
		if not cancel:
			params = urllib.urlencode(	{
							"_rnr_se":acct["gv_data"]["_rnr_se"],
							"forwardingNumber":real_from["number"],
							"outgoingNumber":real_number,
							"subscriberNumber":"undefined",
							"remember":"0",
							"phoneType":real_from["type_code"],
							})

			self.new_call_call_to.set_sensitive(False)
			self.new_call_call_from.set_sensitive(False)
			self.new_call_button.set_sensitive(False)
			self.new_call_cancel.set_sensitive(True)

			data = self.send_post_block(acct, "https://www.google.com/voice/call/connect", params)
			
			failed = False
			if data == None:
				failed = True
				self.new_call_label.set_text(_("Call failed"))
			else:
				ret = json.loads(data)
				if ret["ok"]:
					self.new_call_label.set_text(_("Call dialing."))
				else:
					failed = True
					self.new_call_label.set_text(_("Call failed with code %(code)d") % { "code": ret["data"]["code"] })
			if failed:
				self.new_call_call_to.set_sensitive(True)
				self.new_call_call_from.set_sensitive(True)
				self.new_call_button.set_sensitive(True)
				self.new_call_cancel.set_sensitive(False)
			
		

		else:
			params = urllib.urlencode(	{
							"_rnr_se":acct["gv_data"]["_rnr_se"],
							"cancelType":"C2C",
							})

			self.new_call_call_to.set_sensitive(True)
			self.new_call_call_from.set_sensitive(True)
			self.new_call_button.set_sensitive(True)
			self.new_call_cancel.set_sensitive(False)

			data = self.send_post_block(acct, "https://www.google.com/voice/call/cancel/", params)
			
			failed = False
			if data == None:
				failed = True
				self.new_call_label.set_text(_("Call cancel failed."))
			else:
				ret = json.loads(data)
				if ret["ok"]:
					self.new_call_label.set_text(_("Call cancelled."))
			if failed:
				self.new_call_call_to.set_sensitive(False)
				self.new_call_call_from.set_sensitive(False)
				self.new_call_button.set_sensitive(False)
				self.new_call_cancel.set_sensitive(True)
		
	
		return



	def new_call_draw(self, vbox):
		hbox = gtk.HBox()
		
		label = gtk.Label("To:")
		hbox.pack_start(label, False, False, 2)
		entry = gtk.combo_box_entry_new_text()
		completion = gtk.EntryCompletion()
		liststore = gtk.ListStore(str)
		
		for acct in GMain._accounts:
			for i in acct["contacts"].phoneContacts:
				for j in i["phone"]:
					etext = i["title"] + " - " + j["number"] + " ("
					if j["type"] == "mobile":
						etext += "M)"
					elif j["type"] == "home":
						etext += "H)"
					else:
						etext += "O)"
					entry.append_text(etext)
					liststore.append([etext])
		completion.set_model(liststore)
		completion.set_text_column(0)
		entry.child.set_completion(completion)
		hbox.pack_start(entry, True, True, 2)
		vbox.pack_start(hbox, False, False, 2)

		hbox = gtk.HBox()
		label = gtk.Label(_("Phone to Dial:"))
		hbox.pack_start(label, False, False, 5)
		combo = gtk.combo_box_new_text()
		
		for acct in GMain._accounts:
			try:
				for i in acct["gv_data"]["phones"]:
					etext = acct["name"] + " - " + i["name"] + " - " + i["disp_number"]
					combo.append_text(etext)
			except KeyError, e:
				continue

		hbox.pack_end(combo, True, True, 5)
		vbox.pack_start(hbox, False, False, 5)
		
		
		hbox = gtk.HBox()
		# "Call" as in "place the phone call"
		button = gtk.Button(_("Call"))
		hbox.pack_end(button, False, False, 5)
		button2 = gtk.Button(_("Cancel"))
		hbox.pack_end(button2, False, False, 5)
		vbox.pack_start(hbox, False, False, 5)
		self.new_call_label = gtk.Label()
		hbox.pack_start(self.new_call_label, True, True, 5)

		button.connect("clicked", self.new_call_call, False)
		button2.connect("clicked", self.new_call_call, True)
		
		self.new_call_call_to = entry
		self.new_call_call_from = combo
		self.new_call_button = button
		self.new_call_cancel = button2
		self.new_call_cancel.set_sensitive(False)
		
		vbox.show_all()
		
		return

	def new_call_destroy(self):
		self.new_call_window = None
		return

	def new_call(self, data1=None, data2=None):
		if self.new_call_window != None:
			self.new_call_window.destroy()
			self.new_call_window = None
			return

		if self.num_used() == 0:
			return

		self.new_call_window = GPopupWindow.get_new_popup_window(self.new_call_destroy, 
		                                                        _("Make a Phone Call"),
		                                                        icon=os.path.join(googsystray.BASE_DIR, "icons", self.get_config()["icon"]))

		self.new_call_window.window.set_default_size(int(400*self.get_gconfig()["popup_size"]),-1)
		self.new_call_draw(self.new_call_window.vbox)
		self.new_call_window.show_all()





	def dnd_update(self, data=None):
		for i in GMain._accounts:
			if not i["services"][self.config]:
				continue
			for j in i["gv_data"]["dnd_menuitems"]:
				j.set_active(i["gv_data"]["dnd"])
		
	def dnd_toggled(self, menuitem, account):
		account["gv_data"]["dnd"] = menuitem.get_active()
		
		if self.dnd_updating:
			return
		
		self.dnd_updating = True
		self.dnd_update()
		
		if account["gv_data"]["dnd"]:
			params = urllib.urlencode(	{
						"_rnr_se":account["gv_data"]["_rnr_se"],
						"doNotDisturb":"1",
						})
		else:
			params = urllib.urlencode(	{
						"_rnr_se":account["gv_data"]["_rnr_se"],
						})

		self.send_post_mark(account, "https://www.google.com/voice/m/savednd", None, params)

		self.dnd_updating = False

		
	def add_menu_items(self, menu):
		GIcon.GIcon.add_menu_items(self, menu)
		menuItem = gtk.MenuItem(_("Send SMS Message"))
		menuItem.connect("activate", self.new_sms)
		menu.append(menuItem)
		menuItem = gtk.MenuItem(_("Make a Phone Call"))
		menuItem.connect("activate", self.new_call)
		menu.append(menuItem)
		for i in GMain._accounts:
			if i["services"][self.config]:
				if "gv_data" not in i:
					i["gv_data"] = {}
				if "dnd_menuitems" not in i["gv_data"]:
					i["gv_data"]["dnd_menuitems"] = []
				
				if self.num_used() == 1:
					menuItem = gtk.CheckMenuItem(_("Do Not Disturb"))
				else:
					menuItem = gtk.CheckMenuItem(_("Do Not Disturb (%(account)s)") % {"account": i["name"]})
				menuItem.connect("toggled", self.dnd_toggled, i)
				if "dnd" not in i["gv_data"]:
					i["gv_data"]["dnd"] = False
				menuItem.set_active(i["gv_data"]["dnd"])
				i["gv_data"]["dnd_menuitems"].append(menuItem)
				menu.append(menuItem)
				

	def icon_stop(self):
		self.unbind_hotkey("new_sms")
		self.unbind_hotkey("new_call")
		
	def icon_start(self):
		self.bind_hotkey("new_sms", self.new_sms)
		self.bind_hotkey("new_call", self.new_call)

	def __init__(self):
		self.sms_labels = []
		self.config = "gv"
		self.new_sms_window = None
		self.new_call_window = None
		self.fullCheck = False
		self.dnd_updating = False
		
		GIcon.GIcon.__init__(self)
